
module PfeRefactoringCmds where

import CmdLineParser 
import RefacMoveDef
import RefacRenaming
import RefacDupDef
import RefacNewDef
import RefacRmDef
import RefacAddRmParam
import RefacGenDef
import RefacMvDefBtwMod
import RefacCleanImps
import RefacADT
import RefacDeForest

pfeRefactoringCmds =
  [("liftToTopLevel",(Args "<fileName> <line> <col>" (move UptoTopLevel), "Lift a local declaration to the top level")),
   ("liftOneLevel"  ,(Args "<fileName> <line> <col>" (move UpOneLevel), "Lift a local declaration one level up")),
   ("demote"        ,(Args "<fileName> <line> <col>" (move Down),  "Demote a declaration one level")),
   ("rename"        ,(Args "<fileName> <newName> <line> <col>" rename ,  "Rename a variable name")),
   ("duplicateDef"  ,(Args "<fileName> <newName> <line> <col>" duplicateDef, "Duplicate a definition at the same level")),
   ("removeDef"     ,(Args "<fileName> <line> <col>" removeDef, "Remove a definition if it is not used")),
   ("introNewDef"   ,(Args "<fileName> <newName> <line> <col>" introNewDef , "Introduce a new definition")),
   ("unfoldDef"     ,(Args "<fileName> <line> <col>" unfoldDef, "unfold a definition")),
   ("addOneParameter", (Args "<fileName> <paramName> <line> <col>" addOneParameter, "Add a new parameter to a function/constant definition")),
   ("rmOneParameter", (Args "<fileName> <paramName> <line> <col>" rmOneParameter, "Remove a parameter in a function definition")),
   ("generaliseDef" , (Args "<fileName> <newName> <line> <col>" generaliseDef, "Generalise a definition")),
   ("moveDefBtwMod"  ,(Args "<fileName> <modName> <line> <col>" moveDefBtwMod, "Move a definition to another module")),
   ("cleanImports"  , (Args "<fileName>" cleanImports, "Tidy up the import declarations in the current module")),
   ("mkImpExplicit", (Args "<fileName> <line> <col>"  mkImpExplicit, "make the used entities explicit")),
   ("addToExport"  , (Args "<fileName> <line> <col>"  addToExport,   "add an identifier to the export list")),
   ("rmFromExport" , (Args "<fileName> <line> <col>"  rmFromExport,   "remove an identifier from the export list")),
   ("addFieldLabels", (Args "<fileName> <line> <col>" addFieldLabels, " add field labels to a data type declaration")),
   ("addDiscriminators",(Args "<fileName> <line> <col>" addDiscriminators, " add discriminator functions to a data type declaration")),
   ("addConstructors", (Args "<fileName> <line> <col>" addConstructors, " add constructor functions to a data type declaration")),
  ("elimNestedPatterns",(Args "<fileName> <line> <col>" elimNestedPatterns, "remove the explict uses of data constructors")),
   ("elimPatterns",     (Args "<fileName> <line> <col>" elimPatterns, "remove the explict uses of data constructors")),
   ("createADTMod", (Args "<fileName> <line> <col>" createADTMod, "create a new abstract data type module")),
   ("fromAlgebraicToADT", (Args "<fileName> <line> <col>" fromAlgebraicToADT, "transform an algebriac data type to an ADT")),
   -- for testing interfaces.
   ("fromAlgebraicToADT1", (Args "<fileName> <typeConName>" fromAlgebraicToADT1, "from algebriac to ADT")),
   ("duplicateDef1"  ,(Args "<fileName> ,funName> <newName>" duplicateDef1, "Duplicate a definition at the same level")),
   ("deforest",(Args "<fileName>" deforest, "eliminating intermidiate list"))  
  ]
