
module RefacUtils(module DriftStructUtils, module StrategyLib, module RefacTypeSyn, module RefacLocUtils,
                  initValue, findPNameByPath, hasNameSpace, isValueId,strToModName,
                  modNameToStr, fileNametoModName,clientModsAndFiles,serverModsAndFiles,
                  isAnExistingMod,impQualifier,isInScopeAndUnqualified,sameUnqualNameInScope,
                  causeNameClashInExports,
                  identToName, inScopeNames,wholeModIsExported,isExported,isExplictlyExported,
                  addImportDecl,addDefDecl,appendDefDecl, addItemToExportWithCond,addItemsToExport,pnToEnt,
                  addItemsToImport,addItemsToImport1,addHiding,rmItemFromImport,rmItemsFromExport,
                  rmEntsFromExport,deleteEnt,parseSourceFile,writeRefactoredFiles,rmPrelude,
                  isVarId,isConId,isOperator,isId,isTopLevelPN,isLocalPN,isTopLevelPNT,
                  isQualifiedPN,isFunOrPatName,isLocalFunOrPatName,isTypeCon,
                  isTypeSig,isFunBind,isPatBind,isSimplePatBind,isComplexPatBind,isFunOrPatBind,
                  isClassDecl,isInstDecl,isLast,expInLast,isDirectRecursiveDef,qualifyPName,
                  rmQualifier,showPns,showPNwithLoc,defaultPN,defaultPNT,defaultModName,
                  defaultExp,defaultPat,samePNT,pNTtoPN,pNtoName,pNTtoName,hasModName,
                  idToPNT,pNameToPNT,expToPNT,expToPName,idToExp,pNameToExp,patToPNT,
                  patToPName,idToPat,pNameToPat,mkNewName,defineLoc,useLoc,pNTinRhsUseLoc,
                  isUnqualifiedUsed,locToPNT,locToPName,locToExp,pNamesIn,pNTsIn,definingDecls,
                  defines,definesTypeSig,definedNames,divideDecls,hasFreeVars,removeTypeSig,
                  rmLocs,toRelativeLocs,replaceNameInPN,pNameToStr,renamePN,canBeQualified,
                  findPNT,findPName,findPNames,autoRenameLocalVar,addGuardsToRhs,addParamsToDecls,
                  hsDataConstrs,hsTypeConstrsAndClasses,hsTypeVbls,hsClassMembers,hsFreeAndDeclared,
                  hsFreeAndDeclaredNames,freeAndDeclaredVbls,freeAndDeclaredVblNames,hsVisibleNames,
                  hsVisibleVbls,declsIn, replaceDecls, isDeclaredIn, findEntity,rmTypeSig,commentTypeSig,
                  rmLocalFunOrPatBind ,rmTopLevelFunOrPatBind,duplicateDecl,
                  addEntsToImport,addLocalDecl,getDeclToks,doMoving, doMoving1,rmParams,definingDecls1,simplifyDecl,
                  rmSubs
                  )

    where

import Prelude hiding (putStr,putStrLn,writeFile,readFile)
import PFE0 (getEditorCmds,,getCurrentModuleGraph,parserFlags,addToHistory,allModules)
import PFE3(parseModule,parseModule', parseSourceFile')
import PosSyntax
import TypedIds
import ScopeModule
import UniqueNames hiding (srcLoc)
import HsName
import Names
import HsLexerPass1
import AbstractIO 
import PNT 
import TiPNT
import Maybe
import List  
import Char
import RefacTypeSyn
import RefacLocUtils
import Graph(reverseGraph,reachable)
import NamesEntities 
import Ents
import Relations
import PosName
import QualNames
import TypedIds
import WorkModule
import SourceNames
import PrettyPrint
import Unlit(readHaskellFile,writeHaskellFile)
import ParserOptions
import MUtils 
import EditorCommands(sendEditorModified)
import qualified MT(lift)
-------------------------
import DriftStructUtils  
import StrategyLib hiding (findFile)
------------------------
import HsTokens



--this constant should not be used any more.
initValue= (-1000)

--this function try to find an identifier through a textual interface. More details will be added.
findPNameByPath::String->HsModuleP->Either String PName
findPNameByPath path mod 
  = case  findDeclByPath path mod of
      Left errMsg -> Left errMsg
      Right decl  -> Right $ head $ definedNames decl 
  where     
    findDeclByPath path mod
      = let names = extractPath path
        in findPNByPath' names (hsModDecls mod)
    
    extractPath path = extractPath' [] path
    extractPath' r path =
      case span (/='.') path of
            (name, "")      -> r++[name]
            (name, subPath) -> extractPath' (r++[name]) (tail subPath) 

    findPNByPath' (name:names) [] = Left "Can not find the declaration"
    findPNByPath' (name:names) decls
      = let decl = findDeclByName name decls
        in if decl==[] then Left "Can not find the declaration"
                       else if names==[] then Right (head decl)
                                         else findPNByPath' names (declsIn (head decl))    
    findDeclByName name decls = filter definesName decls
     where
       definesName (Dec (HsFunBind _ ((HsMatch _ (PNT pn _ _) _ _ _):_)))
          = pNtoName pn == name
       definesName (Dec (HsPatBind _ p _ _)) = name == (pNtoName.head.pNamesIn) p 
       definesName  _ = False

------------------------------------------------------------------------------------------
data NameSpace = ValueName | ClassName | TypeCon | DataCon | Other  deriving (Eq, Show)

--hasNameSpace::IdTy PId-> RefacUtils.NameSpace
hasNameSpace Value           = ValueName
hasNameSpace (ConstrOf _ _ ) = DataCon
hasNameSpace (FieldOf _ _ )  = ValueName
hasNameSpace (MethodOf _ _)  = ValueName
hasNameSpace (Class _)       = ClassName
hasNameSpace (Type _)        = TypeCon     -- It is also possible that it is a type variable.
hasNameSpace  _              = Other       -- We don't care about Assertion & Property so far.

-- returns True if an identifier is a value variable.
isValueId (PNT _ ty _) = hasNameSpace ty == ValueName
----------------------------------------------------------------------------------------------
--compose the AST for a module name from a string.
strToModName::String->HsName.ModuleName
strToModName name = if name =="Main" then MainModule "Main.hs"  -- THIS IS BASED ON ASSUMPTION.
                                     else PlainModule name 
--from HsName.ModuleName to string.
modNameToStr::HsName.ModuleName->String
modNameToStr (PlainModule name) = name
modNameToStr (MainModule _)     = "Main"            
                 
--get the module name from the file name.
--fileNametoModName::(Monad m)=>String->m HsName.ModuleName               
fileNametoModName fileName = 
  do gf <- getCurrentModuleGraph
     let fileAndMods = [(m,f)|(f,(m,ms))<-gf]
         f = filter (\(m,f) -> f==fileName) fileAndMods
     if f ==[] then error $ "Can't find module name"
                    else return $ (fst.head) f
 
{-
clientModsAndFiles,serverModsAndFiles::(IxStateMT.WithState (PFE0.PFE0State n i ds ext) m1)
                    =>String->m1 [(HsName.ModuleName, String)]
-}
{-This function returns all the modules (as well as the file names) that imports
  module m either directly or indirectly.  
-}
clientModsAndFiles m =
  do gf <- getCurrentModuleGraph
     let fileAndMods = [(m,f)|(f,(m,ms))<-gf]
         g           = (reverseGraph.(map snd)) gf     
         clientMods  = reachable g [m] \\ [m]
         clients     = concatMap (\m'->[(m,f)|(m,f)<-fileAndMods, m==m']) clientMods
     return clients

{- returns al the modules (as well as the file names) that are imported by the current module
   either directly or indirectly.
-}
serverModsAndFiles m =
   do gf <- getCurrentModuleGraph
      let fileAndMods = [(m,f)|(f,(m,ms))<-gf]
          g           = (map snd) gf  
          serverMods  = reachable g [m] \\ [m]
          servers     = concatMap (\m'->[(m,f)|(m,f)<-fileAndMods, m==m']) serverMods
      return servers

-- returns True is the module name is an exisiting module name, otherwise returns False.
isAnExistingMod m 
  =  do ms<-allModules
        return (elem m ms)

{-Whenever an identifier is imported, the qualified name is imported, the unqualified name
 may or maynot be imported. Given an identifier, `impQualifier` returns the qualifier for
 this identifier.-}
impQualifier::PNT->((Relations.Rel Names.QName (Ents.Ent PosName.Id)))->Maybe HsName.ModuleName
impQualifier pnt@(PNT pname _ _ ) inScopeRel
  = getQualifyModName.map simplifyEnt. filter (sameEnt pnt) $ relToList inScopeRel       
   where  
       sameEnt (PNT pname t1 _) (_,(Ent modName1 ident t2))
            =let modName2=hasModName pname
             in isJust modName2 && modName2 == Just modName1 && 
                pNtoName pname==identToName ident && hasSameNamespace t1 t2
       simplifyEnt (modQualifier, ent@(Ent (PlainModule  modName) ident ty ))
          =(identToName ident, getQualifier modQualifier, modName, ty)
       getQualifyModName simpleEnts 
           =let r=filter isJust $ map (\(_, x, _,_) -> x) simpleEnts
            in if r==[] then Nothing   --means this pname is not imported.
                        else (head r) 
       hasSameNamespace ty1 ty2=hasNameSpace ty1 == hasNameSpace ty2
       

-- returns True if an identifier is inscope and  can be used without a qualifier.          
isInScopeAndUnqualified::String->((Relations.Rel Names.QName (Ents.Ent PosName.Id)))->Bool
isInScopeAndUnqualified id inScopeRel
 = isJust $ find (sameId id) $ relToList inScopeRel
 where 
  sameId id (qual, (Ent modName ident t2))
    = isUnqual qual &&  id==identToName ident

{-Returns True if an unqualified identifier with the same name as pn but different meaning is in scope,
  Otherwise returns False.-}
sameUnqualNameInScope::PName->((Relations.Rel Names.QName (Ents.Ent PosName.Id)))->Bool
sameUnqualNameInScope pn inScopeRel = isJust $ find (sameName pn) $ relToList inScopeRel
  where 
  sameName pn (qual, (Ent modName ident t2))
   = isUnqual qual && pNtoName pn ==identToName ident && hasModName pn /= Just modName

--Id is defined in two modules: HsNames.hs (type Id = String) and PosName.hs (type Id = SN HsNames.Id)
identToName (HsVar (SN i _)) = i
identToName (HsCon (SN i _)) = i

--returns all those names which are inscope.
inScopeNames::[(Relations.Rel Names.QName (Ents.Ent PosName.Id))]->[String]
inScopeNames inScopeRels = map getEntName $ relToList $ unionRels inScopeRels
   where 
     getEntName (qual, (Ent _ ident _))
       =identToName ident

--Returns True if the whole current module is exported by exporting the module name, otherwise False.
wholeModIsExported::HsModuleP->Bool
wholeModIsExported mod
   = let exps    = hsModExports mod
         modName = hsModName mod
     in if isNothing exps
           then True
           else isJust $ find (==(ModuleE modName)) (fromJust exps)
                      
--returns True if the identifier is exported.         
isExported::PNT->[(PosName.Id, Ent PosName.Id)]->Bool
isExported pnt@(PNT pn t1 _) exps
   = if isTopLevelPNT pnt 
       then case hasModName pn of 
               Just modName  -> any (\ (x, (Ent modName1 _ t2))-> show x ==show (pNtoName pn) && modName==modName1
                                     && hasSameNamespace t1 t2) exps
                                   
               Nothing       -> False
       else False 
     where  hasSameNamespace ty1 ty2=hasNameSpace ty1 == hasNameSpace ty2

-- returns True if an identifier is explicitly exported in the exports.
isExplictlyExported::PName->HsModuleP->Bool
isExplictlyExported pn mod
  = findPName pn $ hsModExports mod

--returns True if  adding the newname to the export list will cause name clash in the exports--
--ExpList :: [(n,Ent n)]-- eg: [("f",Ent "A" (HsVar "f") Value)]
causeNameClashInExports::String->HsModuleP->[(PosName.Id, Ent PosName.Id)]->Bool
causeNameClashInExports  newName mod exps
  = let modNames=nub (concatMap (\(x,Ent modName _ _)->if show x==show newName 
                                                        then [modName]
                                                        else []) exps)
    in any (modIsUnQualifedImported mod) modNames                

 where     
    modIsUnQualifedImported mod modName
     =let imps =hsModImports mod
      in isJust $ find (\(HsImportDecl _ (SN modName1 _) qualify  _ h)->modName==modName1 && (not qualify)) imps


-------------------------------------------------------------------------------------------------
{-append an import declaration to the end of the import list in the module, this functions
  modifies both the token stream and the AST
-}
addImportDecl::(MonadState (([PosToken],Bool),t1) m)
                 =>HsModuleP         -- The current module.
                  ->HsImportDeclP    -- the import decl to be add.
                  ->m HsModuleP      
addImportDecl mod@(HsModule _ _ _ imp decls) impDecl
 = do ((toks,_),others)<-get   
      let loc1 = if (imp \\ prelimps) /=[]
                 then let (_, (endRow,_)) = startEndLocIncComments toks (last imp)  
                      in (endRow+1, 0)   
                 else if decls /=[] 
                       then let ((startRow,l),_) = startEndLocIncComments toks (head decls)
                            in (startRow, 0)  -- should not be startRow-1.bug fixed 10/06/04.
                       else simpPos0 --This should not happen.No point to add imports to a module without any definitions.
          (toks1, toks2) = break (\t->tokenPos t>=loc1) toks
          newTok = mkToken Varid  loc1 $ "\n"++(render.ppi) impDecl ++"\n"  -- pretty print the token stream.
          toks'  = toks1 ++ [newTok] ++ toks2
      put ((toks',modified),others)
      return (mod {hsModImports=imp++[impDecl]})

{- add a function definition/pattern binding  right to the beginning of the definition declaration list, but
   after the data type declarations if there is any. In the case that the defDeclToks is empty, the 
   definition will be pretty-printed. This function modifies both the token stream and the AST.-}

addDefDecl::(MonadState (([PosToken],Bool),t1) m)
                    =>([HsDeclP], Maybe [PosToken])  -- the declaration to be added, in both AST and Token stream format.
                    ->HsModuleP              -- the current module.
                    ->m HsModuleP            -- the result module.
addDefDecl (defDecl, defDeclToks) mod@(HsModule _ _ _ _ decls)
  = do let (decls1,decls2)=break (\x->isFunOrPatBind x || isTypeSig x) decls      
       ((toks,_),others)<-get   
       let loc1 = if decls2/=[]  -- there are function/pattern binding decls. 
                   then let ((startRow,_),_) = startEndLocIncComments toks (head decls2)
                        in  (startRow, 1)
                   else simpPos0  -- no function/pattern binding decls in the module.
           (toks1, toks2) =
              if loc1==simpPos0
                then (toks, [])
                else break (\t->tokenPos t>=loc1) toks
           defDeclToks' =
             if isNothing defDeclToks 
               then mkTokensWithIndent Varid loc1 (astToSource defDecl) True ++ [newLnToken,newLnToken]
               else if endsWithNewLn (glast "addDefDecl" defDeclToks') 
                      then defDeclToks' 
                      else defDeclToks' ++ [newLnToken]
           toks' = toks1 ++ {-[newLnToken]++ -} defDeclToks' ++ toks2
       put ((toks',modified),others)                                    
       return (mod {hsModDecls=decls1++defDecl++decls2})

{- add a function definition/pattern binding right after the definition of pn in the declaration list ds.
   This function modifies both the token stream and the AST. -}
appendDefDecl::(MonadState (([PosToken],Bool),t1) m)
               => PName   
                ->[HsDeclP]  -- the decl to be added, it may include the type signature, so a list of decls.
                ->[HsDeclP]  
                ->m [HsDeclP]
appendDefDecl pn declToAdd ds
  = do let (before,after) = break (defines pn) ds   -- * Need to handle the case that 'after' is empty.
            --'after' can not be empty, no problem with 'head'
           ds'=before++[head after]++declToAdd ++tail after   
           --Start token stream updating
       ((toks,_),others)<-get   
       let (startPos,endPos) = startEndLocIncFowComment toks (head after) 
            --divide token stream into two parts.
           (toks1,toks2) = break (\t->tokenPos t>endPos) toks
           (_,toks12) = break (\t->tokenPos t>=(fst startPos,0)) toks1 
            --get the toks defining pn
           defToks = dropWhile (\t->tokenPos t<startPos) toks12
           offset = length (concatMap tokenCon (takeWhile (\t->tokenPos t<startPos) toks12))
           toksToAdd=mkToken Varid (fst endPos+1,snd startPos) 
                               $ replicate offset ' '++ (render.ppi) declToAdd  -- pretty-print the token stream.          
           toks' = if toks1/=[] && endsWithNewLn  (glast "addDefaultActualArgDecl" toks1)
                      then  toks1++[newLnToken,toksToAdd,newLnToken]++ compressPreNewLns toks2  
                      else  replaceToks toks startPos endPos (defToks++[newLnToken,newLnToken,toksToAdd]) 
       put ((toks',modified),others)   
       return ds'        


{- append a function to the end of the decl list of 'parent'. if such a decl list does not exist, then create one}
-}
--addLocalDecl::((MonadState (([PosToken],Bool),t) m),StartEndLoc t,DeclsIn t)=>t->HsDeclP->m [HsDeclP] 
addLocalDecl parent newFun
  =do ((toks,_),others)<-get   
      let localDecls=declsIn parent  --localDecls may be empty.
          newFunSource=astToSource newFun  --pretty print the AST.
          (startPos@(_,startCol),endPos'@(endRow',_))  --endPos' does not include the following newline or comment.
             =if localDecls==[] then getStartEndLoc toks parent    --The 'where' clause is empty
                                else getStartEndLoc toks localDecls 
          toks1=dropWhile (\t->tokenPos t<=endPos') toks 
          ts1=takeWhile (\t->isWhite t && ((not.isMultiLineComment) t) && tokenRow t==endRow')  toks1    
           --nextTokPos is only used to test whether there is a 'In' or a nested comment.                
          nextTokPos= case (dropWhile (\t->isWhite t && ((not.isMultiLineComment) t) && tokenRow t==endRow') toks1) of
                           [] -> simpPos0 
                           l  -> (tokenPos.ghead "addLocalFunInToks") l 
          needNewLn=if nextTokPos==simpPos0  --used to decide whether add a new line character before a introduced fun.
                      then if toks1==[] then True
                                        else (not.endsWithNewLn) (last ts1) 
                      else endRow'==fst nextTokPos 
          endPos@(endRow,_)=if ts1==[] then endPos'
                                       else tokenPos (last ts1)
          t=if localDecls==[]
              then (mkTokensWithIndent Special (endRow+1,startCol+2) ["where"] True) ++[newLnToken]++
                    mkTokensWithIndent Varid (endRow+2,startCol+4) newFunSource True -- ++[newLnToken]
              else mkTokensWithIndent Varid  (endRow+1,startCol) newFunSource True
          oldToks'=getToks (startPos,endPos) toks
          newToks'=if needNewLn then oldToks' ++(newLnToken:t)  
                                else oldToks'++ t++[newLnToken]           
          toks'=replaceToks toks startPos endPos newToks'
      put ((toks',modified),others) 
      return (replaceDecls parent (declsIn parent ++ [newFun]))

{-Remove the type signature which defines pn's type from the declaration list.
  this function modifies both the token stream and the AST.
-}
rmTypeSig::(MonadState (([PosToken],Bool),t1) m)
            => PName   
            ->[HsDeclP]  -- the decl list which contains the type signature to be removed.
            ->m [HsDeclP]
rmTypeSig pn decls  
 =let (decls1,decls2)=break  (definesTypeSig pn) decls
  in if decls2/=[] then    --There is a type signature for pn
       do ((toks,_),others)<-get   
          let (toks',decls')=
               let sig@(Dec (HsTypeSig loc is c tp))=ghead "rmTypeSig" decls2  -- as decls2/=[], no problem with head 
                   (startPos,endPos)=getStartEndLoc toks sig 
               in if length is>1   --This type signature also defines the type of  variables other than pn
                     then let newSig=(Dec (HsTypeSig loc (filter (\x-> (pNTtoPN x)/=pn) is) c tp))
                             --pretty print the type signature, and put it into a new token 
                             --attention:The token type can not be WhiteSpace 
                              t=mkTokensNoFstLnIndent Varid startPos  (astToSource newSig)
                          in (replaceToks toks startPos endPos t,(decls1++[newSig]++tail decls2))
                     else  ((deleteToks toks startPos endPos),(decls1++tail decls2)) 
          put ((toks',modified),others)
          return decls' 
      else return decls  --No type signature for pn

{-Comment the type signature which defines pn's type from the declaration list.
  this function modifies both the token stream  and removes the type signature from the AST.
-}
commentTypeSig::(MonadState (([PosToken],Bool),t1) m)
            => PName   
            ->[HsDeclP]  -- the decl list which contains the type signature to be removed.
            ->m [HsDeclP]
commentTypeSig pn decls  
 =let (decls1,decls2)=break  (definesTypeSig pn) decls
  in if decls2/=[] then    --There is a type signature for pn
       do ((toks,_),others)<-get   
          let (toks',decls')=
               let sig@(Dec (HsTypeSig loc is c tp))=ghead "rmTypeSig" decls2  -- as decls2/=[], no problem with head 
               in if length is>1   --This type signature also defines the type of  variables other than pn
                     then let newSig=(Dec (HsTypeSig loc (filter (\x-> (pNTtoPN x)/=pn) is) c tp))
                              pnt = ghead "commentTypeSig" $ filter (\x->pNTtoPN x==pn) is 
                              (startPos,endPos) = getStartEndLoc toks pnt 
                          in ((commentToks (startPos, endPos) toks),(decls1++[newSig]++tail decls2))
                     else let  (startPos,endPos)=getStartEndLoc toks sig 
                          in  ((commentToks  (startPos, endPos) toks),(decls1++tail decls2)) 
          put ((toks',modified),others)
          return decls' 
      else return decls  --No type signature for pn

--Remove the local declaration defining pn from decls(which is a list of declarations).
{- The difference between removing a top level declaration and a local declaration is:
   if the local declaration to be removed is the only declaration in current declaration list, 
   then the 'where'/ 'let'/'in' enclosing this declaration should also be removed.
   Whereas, when a only top level decl is removed, the 'where' can not be removed.
-}
rmLocalFunOrPatBind::(MonadState (([PosToken],Bool),t1) m)
                     =>PName
                       ->[HsDeclP]
                      ->m ([HsDeclP],[PosToken])
rmLocalFunOrPatBind pn decls  
  =do ((toks,_),others)<-get   
      let (decls1,decls2)=break (defines pn) decls
          decl=ghead "rmLocalFunOrPatBind:decl" decls2   --the declaration to be removed, decls2 won't be empty.
          (startPos,endPos)=getStartEndLoc toks decl   --startEndLoc toks decl  
          (startPos',endPos')=startEndLocIncComments toks decl       
          --(startPos',endPos')=startEndLocIncFowComment toks decl 
          toks'=if length decls==1 --only one decl, which means the accompaning 'where','let' or'in' should be removed too.
                   then let (toks1,toks2)=break (\t->tokenPos t>=startPos) toks --devide the token stream.
                              --get the  'where' or 'let' token
                            rvToks1=dropWhile (not.isWhereOrLet) (reverse toks1)
                            --There must be a 'where' or 'let', so rvToks1 can not be empty.
                            whereOrLet=ghead "rmLocalFunPatBind:whereOrLet" rvToks1 
                            --drop the 'where' 'or 'let' token
                            toks1'=takeWhile (\t->tokenPos t<tokenPos whereOrLet) toks1
                            --remove the declaration from the token stream.
                            toks2'=dropWhile (\t->tokenPos t<=endPos') toks2
                            --get the remained tokens after the removed declaration.
                            remainedToks=dropWhile isWhite toks2'
                        in if remainedToks==[] 
                             then --the removed declaration is the last decl in the file.
                                  (compressEndNewLns toks1'++ compressPreNewLns toks2') 
                             else if --remainedToks/=[], so no problem with head.
                                    isIn (ghead "rmLocalFunPatBind:isIn"  remainedToks)  
                                         || isComma (ghead "rmLocalFunPatBind:isComma" remainedToks) 
                                        --There is a 'In' after the removed declaration.
                                   then deleteToks toks (tokenPos whereOrLet)
                                                $ tokenPos (ghead "rmLocalFunPatBind:tokenPos"  remainedToks) 
                                        --delete the decl and adjust the layout                      
                                   else if isCloseSquareBracket (ghead "rmLocalFunPatBind:isCloseSquareBracker" remainedToks) &&
                                           (isBar.(ghead "rmLocalFunPatBind:isBar")) (dropWhile isWhite (tail rvToks1))
                                         then deleteToks toks (tokenPos((ghead "rmLocalFunPatBind") 
                                                        (dropWhile isWhite (tail rvToks1)))) endPos'
                                         else deleteToks toks (tokenPos whereOrLet) endPos' 
                        --there are more than one decls
                   else  deleteToks toks startPos' endPos'
      put ((toks',modified),others)  --Change the above endPos' to endPos will not delete the following comments.
      --This function also returns the removed token stream. this can be used when moving a definition.
      return (decls1++tail decls2, getToks (startPos',endPos') toks)

--Remove a function/pattern declaration from top level.
rmTopLevelFunOrPatBind  pn  decls  
  =do ((toks,_),others)<-get   
      let (decls1,decls2)=break (defines pn) decls
          decl=ghead "rmTopLevelFunOrPatBind"  decls2  --decls2/=[], no problem with 'head'.
          (startLoc, endLoc)=startEndLocIncComments toks decl      
          toks'=deleteToks toks startLoc endLoc
      put ((toks',modified),others)
      return (decls1++tail decls2) 


{-there maybe fun/simple pattern binding and type signature in the duplicated decls
  function binding, and type signature are handled differently here: the comment and layout
  in function binding are preserved.The type signature is outputted by pretty printer, so
  the comments and layout are NOT preserved.
 -}
duplicateDecl decls pn newFunName
 = do                 
      let declsToDup = definingDecls [pn] decls True False    
          funBinding = filter isFunOrPatBind declsToDup     --get the fun binding.
          typeSig    = filter isTypeSig declsToDup      --get the type signature.                         
      ((toks,_), others)<-get   
      let ((startRow,startCol),(endRow,endCol))
            = startEndLocIncComments {-startEndLoc-} toks funBinding  
          {-take those tokens before (and include) the function binding and its following
            white tokens before the 'new line' token. (some times the function may be followed by 
            comments) -}
          (toks1,_) = break (\t->tokenPos t>(endRow,endCol)) toks
          --take those token after (and include) the function binding
          toks2     = dropWhile (\t->tokenPos t<(startRow,startCol) || isNewLn t) toks
      put((toks2,modified), others)
      --rename the function name to the new name, and update token stream as well
      funBinding'<-renamePN pn Nothing newFunName True funBinding
      --rename function name in type signature  without adjusting the token stream
      typeSig'  <- renamePN pn Nothing newFunName False typeSig
      ((toks2,_), others)<-get    
      let newLineTok = if toks1/=[] && endsWithNewLn (glast "doDuplicating" toks1)
                         then [newLnToken]
                         else [newLnToken,newLnToken] 
          toks'= if typeSig/=[] 
                 then let offset = tokenCol ((ghead "doDuplicating") (dropWhile (\t->isWhite t) toks2))
                          sigSource = concatMap (\s->replicate (offset-1) ' '++s++"\n")((lines.render.ppi) typeSig')
                          t = mkToken Whitespace (0,0) sigSource  
                      in  (toks1++newLineTok++[t]++(whiteSpacesToken (0,0) (startCol-1))++toks2)
                 else (toks1++newLineTok++(whiteSpacesToken (0,0) (startCol-1))++toks2) 
      put ((toks',modified),others)
      return (typeSig'++funBinding')



------------------------------------------------------------------------------

{-Conditionally add an export enitity to the export list, that is only add funName to the export
  list if pn exists in the export list.
-}
addItemToExportWithCond::(MonadState (([PosToken],Bool),t1) m) 
                        =>HsModuleP        -- the current module.
                        ->PName            -- the PName to be checked.
                        ->PName            -- the PName to be added.
                        ->m HsModuleP      -- the result module.
addItemToExportWithCond mod@(HsModule loc modName exps imps ds) pn funName
    = case exps  of
       Just ents ->let (e1,e2) = break (findPName pn) ents
                   in if e2 /=[]  
                        then do ((toks,_),others)<-get   
                                let e = (ghead "addVarItemInExport" e2)
                                e'<-renamePN pn Nothing (pNtoName funName) False e
                                let (_,endPos) = getStartEndLoc toks e
                                    (t, (_,s)) = ghead "addVarItemInExport" $ getToks (endPos,endPos) toks
                                    newToken = mkToken t endPos (s++","++ (render.ppi) e') 
                                    toks' = replaceToks toks endPos endPos [newToken]
                                put ((toks',modified),others)                                   
                                return (HsModule loc modName (Just (e1++[e,e']++tail e2)) imps ds)
                        else return mod 
                     
       Nothing   -> return mod  

{-Add items at beginning of export list, if there is no explict export list and the parameter
  `addItemsToExport` is True, then create a explicit export list. 
-}
addItemsToExport::(MonadState (([PosToken],Bool),t1) m) 
                 =>HsModuleP            -- the current module.
                 ->[HsExportEntP]       -- the entities to be added.
                 ->Bool                 -- create an explicit list or not.
                 ->m HsModuleP          -- the result module.
addItemsToExport mod [] createExplictExp= return mod
addItemsToExport mod@(HsModule _ _ (Just ents) _ _) entsToAdd createExplictExp
    = do ((toks,_),others)<-get
         let (t, (pos,s))=fromJust $ find isOpenBracket toks  -- s is the '('
             newToken = if ents /=[] then  (t, (pos,(s++showPns (render.ppi) entsToAdd++",")))
                                     else  (t, (pos,(s++showPns (render.ppi) entsToAdd)))
             pos'= simpPos pos
             toks' = replaceToks toks pos' pos' [newToken]
         put ((toks',modified),others)  
         return mod {hsModExports=Just (entsToAdd++ ents)}

addItemsToExport mod@(HsModule _  modName'@(SN modName (SrcLoc fileName c row col))
                       Nothing imps ds) entsToAdd createExplictExp
  =case createExplictExp of 
       True ->do ((toks,_),others)<-get
                 let pos = (row,col)
                     newToken = mkToken Varid pos (modNameToStr modName++ "(" 
                                         ++ showPns (render.ppi) entsToAdd++")")
                     toks' = replaceToks toks pos pos [newToken]
                 put  ((toks', modified), others)       
                 return mod {hsModExports=Just entsToAdd}
       False ->return mod               
-------------------------------------------------------------------------------------

addEntsToImport imp@(HsImportDecl l m q a (Just(h,ents))) ents'
  = do  ((toks,_),others)<-get 
        let (_,endPos)=getStartEndLoc toks (glast "addEntsToImport" ents)
            (t, (_,s))=ghead "addEntsToImport" $ getToks (endPos,endPos) toks
            newToken=mkToken t endPos (s++","++  showPns (render.ppi) ents')
            toks'=replaceToks toks endPos endPos [newToken]
        put ((toks',modified),others)               
        return (HsImportDecl l m q a (Just(h,ents'++ents)))  
addEntsToImport imp ents'  = return imp

{- `addItemsToImport' adds identifiers to the explicit import/hiding list of an import decl conditionally,
    that is it depends on whether the Pname (3rd argument) occurs in the import decl or not.-}
addItemsToImport::(MonadState (([PosToken],Bool),t1) m) 
                 =>HsName.ModuleName    -- the imported module name.
                 ->HsModuleP            -- the current module.
                 ->Maybe PName                -- the PName to check.
                 ->[String]             -- the identifiers to be added if the PName exists in the import decl.
                 ->m HsModuleP          -- the result module.
addItemsToImport serverModName mod pn [] = return mod 
addItemsToImport serverModName mod pn funNames
 =applyTP (full_buTP (idTP `adhocTP` inImport)) mod
  where 
    inImport (imp@(HsImportDecl loc m@(SN modName _) qual  as h):: HsImportDeclP)
      | serverModName == modName && (if isJust pn then findPName (fromJust pn) h else True)
       = case h of
           Nothing        -> return imp                     
           Just (b, ents) -> do let ents'=map (\x-> Var (idToPNT x)) funNames
                                ((toks,_),others)<-get
                                let (_,endPos)=getStartEndLoc toks (glast "addItemsToImport" ents)
                                    (t,(_,s))=ghead "addItemsToImport" $ getToks (endPos,endPos) toks
                                    newToken = mkToken t endPos (s++","++showPns (render.ppi) ents')
                                    toks'=replaceToks toks endPos endPos [newToken]
                                put ((toks',modified),others)
                                return (HsImportDecl loc m qual as (Just (b, ents++ents')))
    inImport imp = return imp



---- This function is only used by the 'RefacADT.hs' module, I haven't work out a way to refactor it.
addItemsToImport1 serverModName typeCon selectors discriminators constructors mod
  =applyTP (full_buTP (idTP `adhocTP` inImport)) mod
  where 
    inImport (imp@(HsImportDecl loc m@(SN modName _) qual  as h):: HsImportDeclP)
      | serverModName == modName &&  findPName typeCon h
       = case h of
           Nothing        -> return imp                     
           Just (b, ents) -> do let funs=findEntsToAdd typeCon selectors discriminators constructors ents
                                if (funs==[]) then return imp
                                  else do let ents'=map (\x->Var (idToPNT x)) funs
                                          ((toks,_),others)<-get
                                          let (_,endPos)=getStartEndLoc toks (glast "addItemsToImport" ents)
                                              (t,(_,s))=ghead "addItemsToImport" $ getToks (endPos,endPos) toks
                                              newToken = mkToken t endPos (s++","++showPns (render.ppi) ents')
                                              toks'=replaceToks toks endPos endPos [newToken]
                                          put ((toks',modified),others)
                                          return (HsImportDecl loc m qual as (Just (b, ents++ents')))
    inImport imp = return imp

   
    findEntsToAdd typeConPN selectors discriminators constructors ents
      = nub $ concatMap (match typeConPN) ents      
      where 

      match typeConPN (AllSubs pnt)
         | pNTtoPN pnt == typeConPN
        = concatMap snd selectors ++ map snd (discriminators++constructors)
      match typeConPN (ListSubs pnt idents)    -- refactor this 
        | pNTtoPN pnt == typeConPN
        = let r1 = concatMap (\(dataCon, funs)->if elem (pNtoName dataCon) identNames
                                                 then funs 
                                                 else []) selectors 
              r2 = concatMap (\(dataCon, fun)->if elem (pNtoName dataCon) identNames
                                                then [fun] 
                                                else []) (discriminators++constructors)
          in r1++r2
       where
          identNames= map identToName  idents 
          identToName (HsVar i) = pNTtoName i
          identToName (HsCon i) = pNTtoName i
      match _ _ = []

  
 --add items in the hiding list of an import declaration which imports the server module..
addHiding::(MonadState (([PosToken],Bool),t1) m) 
            =>HsName.ModuleName    -- the imported module name.
            ->HsModuleP            -- the current module.
            ->[PName]              -- the PNames to be hided.
            ->m HsModuleP          -- the result module.
addHiding serverModName mod pns
   = applyTP (full_tdTP (idTP `adhocTP` inImport)) mod
  where 
    inImport (imp@(HsImportDecl loc (SN modName _) qual  as h)::HsImportDeclP)
      | serverModName == modName  && not qual
       = case h of
           Nothing ->do ((toks,_),others)<-get  
                        let (_,endPos)=getStartEndLoc toks imp
                            (t,(_,s)) = head $ getToks (endPos,endPos) toks 
                            newToken=mkToken t endPos (s++" hiding ("++showPns pNtoName pns++")")
                            toks'=replaceToks toks endPos endPos [newToken]
                        put ((toks',modified),others)    
                        return (replaceHiding imp (Just (True, map mkNewEnt pns )))
           Just (True, ents) ->do ((toks,_),others)<-get  
                                  let (_,endPos)=getStartEndLoc toks imp
                                      (t, (_,s))=head $ getToks (endPos,endPos) toks
                                      newToken=mkToken t endPos (","++showPns pNtoName pns ++s)
                                      toks'=replaceToks toks endPos endPos [newToken]
                                  put ((toks',modified),others) 
                                  return (replaceHiding imp  (Just (True, (map mkNewEnt  pns)++ents))) 
           Just (False, ent)  -> return imp 
    inImport x = return x

    mkNewEnt pn = (Var (PNT pn Value (N (Just loc0))))
    replaceHiding (HsImportDecl loc modName qual as h) h1 = HsImportDecl loc modName qual as h1    


--remove those entities specified by the pns from the entity list in the imports.
rmItemFromImport::(MonadState (([PosToken],Bool),t1) m) 
                   =>HsModuleP
                   ->[PName]
                   ->m HsModuleP
rmItemFromImport mod pns
  = applyTP (full_buTP (idTP `adhocTP` inImport)) mod
   where 
     inImport (imp@(HsImportDecl loc modName qual  as h)::HsImportDeclP)
      | any (flip findPName imp) pns
       = case h of
           Just (b, ents) ->
             do let matchedEnts=findEnts pns ents
                if  matchedEnts==[] 
                  then return imp
                  else if length matchedEnts == length ents   
                         then do ((toks,_),others)<-get  
                                 let (startPos,endPos)=getStartEndLoc toks ents
                                     toks'=deleteToks toks startPos endPos
                                 put ((toks',modified),others)
                                 return (HsImportDecl loc modName qual as (Just (b,[])))
                         else do ((toks,_),others)<-get  
                                 let remainedEnts=concatMap (\pn->filter (not.match pn) ents) pns 
                                     toks'=foldl deleteEnt toks $ map (getStartEndLoc toks) matchedEnts
                                 put ((toks',modified),others)
                                 return (HsImportDecl loc modName qual as (Just (b, remainedEnts)))
           _ ->return imp 
     inImport x = return x
   
     findEnts pns ents =nub $ concatMap (\pn->filter (match pn) ents) pns

     -- this function does not check this sub entities of the ListSubs. any problems?
     match::PName -> EntSpec PNT ->Bool
     match pn (Var pnt) = pNTtoPN pnt == pn
     match pn (Abs pnt) = pNTtoPN pnt == pn
     match pn (AllSubs pnt) = pNTtoPN pnt == pn
     match pn (ListSubs pnt _) = pNTtoPN pnt == pn

rmSubs typeCon 
  = applyTP (full_buTP (idTP `adhocTP` inEntSpec))
  where
   inEntSpec (ent@(AllSubs pnt)::EntSpec PNT)
     | pNTtoPN pnt == typeCon 
      =do let ent'=Abs pnt
          updateExpToks ent ent'
          return ent'
   inEntSpec (ent@(ListSubs pnt _))
     | pNTtoPN pnt == typeCon 
     = do let ent'=Abs pnt
          updateExpToks ent ent'
          return ent'   
   inEntSpec ent = return ent
     
---------------------------------------------------------------------------------------
{-Both `rmItemsFromExport` and `rmEntsFromExport` removes entities from the export list,but
  they are different in the interface.
-}

{-remove those entities specified by the modNames(in the case a whole module is exported) 
  and PNames(in the case that individual entities are explicitely exported from the export list.
-}
rmItemsFromExport::(MonadState (([PosToken],Bool),t1) m) 
                   =>HsModuleP
                    ->([HsName.ModuleName],[PName])
                    ->m HsModuleP
rmItemsFromExport mod@(HsModule loc modName exps imps ds) (modNames, pns)
  =if isNothing exps
     then return mod
     else do let ents =findEnts (modNames, pns) (fromJust exps)
             rmEntsFromExport mod ents 
  where   
    findEnts (modNames, pns) ents
      =let ms = concatMap (\m ->filter (\e -> case e of 
                                         ModuleE (SN m' _) -> m==m'
                                         EntE e'    -> False) ents) modNames 
           es =concatMap (\pn->filter (\e ->case e of 
                                            ModuleE _ -> False
                                            EntE e'    -> match pn e') ents) pns 
       in (ms++es)

    match::PName -> EntSpec PNT ->Bool
    match pn (Var pnt) = pNTtoPN pnt == pn
    match pn (Abs pnt) = pNTtoPN pnt == pn
    match pn (AllSubs pnt) = pNTtoPN pnt == pn
    match pn (ListSubs pnt _) = pNTtoPN pnt == pn

-- remove the specified entities from the module's export list
rmEntsFromExport::(MonadState (([PosToken], Bool), t1) m)
                     =>HsModuleP            --the original mod
                       ->[HsExportEntP]     --the entities to be deleted 
                       ->m HsModuleP        --the result module.
rmEntsFromExport mod@(HsModule loc modName exps@(Just es) imps ds) ents 
  = do exps'<- if ents==[] 
                  then return exps
                  else if length ents == length es 
                         then do ((toks,_),others)<-get             
                                 let (startPos,endPos) = getStartEndLoc toks ents
                                     toks'= deleteToks toks startPos endPos
                                 put ((toks',modified),others)
                                 return (Just [] )  -- should not remove the empty bracket!!!
                         else do ((toks,_),others)<-get 
                                 let toks' = foldl deleteEnt toks $ map (getStartEndLoc toks) ents
                                 put ((toks',modified),others)
                                 return (Just (es \\ ents))                 
       return (HsModule loc modName exps' imps ds)
rmEntsFromExport mod _ = return mod 

--This function is only used by this module, and should not be exported.
deleteEnt toks (startPos, endPos)
  = let (toks1,toks2)=break (\t->tokenPos t>=startPos) toks
        previousTok=ghead "deleteEnt" $ dropWhile isWhiteSpace $ reverse toks1
        toks' = dropWhile isWhiteSpace $ dropWhile (\t->tokenPos t<=endPos) toks2
        nextTok = ghead "deleteEnt" toks'
        startPos'=if isComma previousTok && (not (isComma nextTok)) then tokenPos previousTok else startPos
    in if isComma nextTok                    
         then let remainedToks = tail toks' 
              in if remainedToks /= [] 
                   then let whites = takeWhile isWhiteSpace remainedToks
                        in if whites /= [] then deleteToks toks startPos' (tokenPos (last whites))
                                           else deleteToks toks startPos' (tokenPos nextTok)
                   else deleteToks toks startPos' (tokenPos nextTok)
         else deleteToks toks startPos' endPos  
 
---------------------------------------------------------------------------------------------
{-parses a source file and returns a four-element tuple like:
  (Rel PNT (Ent PosName.ModuleName),ExpRel PosName.ModuleName, HsModuleP, [PosToken])
-}
parseSourceFile (filename::String)
   = (checkScope @@ parseSourceFile') filename 
  where 
   checkScope (ts,(((wm,_),mod),refs))
     = check (checkRefs refs) >> return (inscpRel wm, exports wm, mod, expandNewLnTokens ts) 

   check [] = done
   check errs = fail $ pp $ "Scoping errors" $$ vcat errs   

   --preprocssing the token stream to expand the white spaces to individual tokens.
   expandNewLnTokens::[PosToken]->[PosToken]
   expandNewLnTokens ts = concatMap expand ts
     where
       expand tok@(Whitespace,(pos,s)) = doExpanding pos s                
       expand x = [x]

       doExpanding pos [] =[]
       doExpanding pos@(Pos c row col) (t:ts)
        = case t of 
              ' ' -> (Whitespace, (pos,[t])):(doExpanding (Pos c row (col+1)) ts)
              '\n'-> (Whitespace, (pos,[t])):(doExpanding (Pos c (row+1) 1) ts)
              '\t'-> (Whitespace, (pos,[t])):(doExpanding (Pos c row (col+1)) ts)

------------------------------------------------------------------------------------------------
{--Output a list of files. The parameter `isSubRefactor` specifies whether the current refactoring is
   a sub-refactoring of a composite one.
-}
writeRefactoredFiles (isSubRefactor::Bool) (files::[((String,Bool),([PosToken], HsModuleP))]) 
  = do let modifiedFiles = filter (\((f,m),_)->m==modified) files
       addToHistory isSubRefactor $ map (fst.fst) modifiedFiles
       mapM_ modifyFile modifiedFiles
       mapM_ writeTestDataForFile files
     where
       modifyFile ((fileName,_),(ts,mod)) = do
           --let source =(render.ppi) mod 
           let source = concatMap (snd.snd) ts
           seq (length source) $ writeHaskellFile fileName source
           editorCmds <-getEditorCmds 
           MT.lift $ sendEditorModified editorCmds fileName        
       writeTestDataForFile ((fileName,_),(ts,mod)) = do
           --seq (length source) $ writeFile (createNewFileName "_TokOut" fileName) source 
           writeHaskellFile (createNewFileName "AST" fileName) ((render.ppi.rmPrelude) mod)   
       createNewFileName str fileName 
          =let (name, posfix)=span (/='.') fileName
           in (name++str++posfix) 

--------------------------------------------------------------------------------------- 
-----Remove the 'Prelude' imports added by Programatica------------------------------
rmPrelude::HsModuleP->HsModuleP
rmPrelude (HsModule s m e is ds) = HsModule s m e (is \\ prelimps) ds

prelimps = [HsImportDecl loc0  (SN (PlainModule "Prelude") loc0)  True Nothing Nothing,
            HsImportDecl loc0  (SN (PlainModule "Prelude") loc0) False Nothing Nothing]
    

--Returns True if a string is lexically a valid variable/constructor identifier.
isVarId,isConId::String->Bool

isVarId id =isId id && isSmall (ghead "isVarId" id) 
     where isSmall c=isLower c || c=='_'

isConId id =isId id && isUpper (ghead "isConId" id)

--Returns True if a string is lexically a valid operator.
isOperator::String->Bool
isOperator id = id /= [] && isOpSym (ghead "isOperator" id) &&
                isLegalOpTail (tail id) && not (isReservedOp id)
   where

    isOpSym id = elem id opSymbols
       where opSymbols = ['!', '#', '$', '%', '&', '*', '+','.','/','<','=','>','?','@','\'','^','|','-','~']

    isLegalOpTail tail = all isLegal tail
       where isLegal c = isOpSym c || c==':'

    isReservedOp id = elem id reservedOps
       where reservedOps = ["..", ":","::","=","\"", "|","<-","@","~","=>"]

{-Returns True if a string lexically is an identifier. *This function should not be exported.*
-}  
isId::String->Bool
isId id = id/=[] && isLegalIdTail (tail id) && not (isReservedId id)
  where
    isLegalIdTail tail=all isLegal tail
        where isLegal c=isSmall c|| isUpper c || isDigit c || c=='\''

    isReservedId id=elem id reservedIds 
      where reservedIds=["case", "class", "data", "default", "deriving","do","else" ,"if",
                         "import", "in", "infix","infixl","infixr","instance","let","module",
                         "newtype", "of","then","type","where","_"]

    isSmall c=isLower c || c=='_'

-----------------------------------------------------------------------------
isTopLevelPN,isLocalPN::PName->Bool

--returns True if an identifier is a toplevel PName.
isTopLevelPN (PN i (G _ _ _))=True
isTopLevelPN _ =False

--returns True if an identifier is a local PName.
isLocalPN (PN i (S _))=True
isLocalPN _ =False

--returns True if an PNT is a toplevel PNT.
isTopLevelPNT::PNT->Bool
isTopLevelPNT = isTopLevelPN.pNTtoPN

--returns True if a PName is a qualified PName.
isQualifiedPN::PName->Bool
isQualifiedPN (PN (Qual mod id) _)=True
isQualifiedPN _ =False 

--returns True if pn is a function/pattern name
isFunOrPatName pn 
   =isJust.(applyTU (once_tdTU (failTU `adhocTU` worker)))
     where
        worker (decl::HsDeclP)
           | defines pn decl=Just True
        worker _ =Nothing

--return True if pn is a local function/pattern name
isLocalFunOrPatName pn scope
 =isLocalPN pn && isFunOrPatName pn scope

--------------------------------------------------------------------------------
-- returns True if a PNT is a type constructors
isTypeCon :: PNT -> Bool
isTypeCon (PNT pn (Type typeInfo) _) = defType typeInfo == Just Data
isTypeCon _ = False 

--returns True if a declaration is a type signature declaration.
isTypeSig ::HsDeclP->Bool
isTypeSig (Dec (HsTypeSig loc is c tp))=True
isTypeSig _=False

--returns True if a declaration is a function definition.
isFunBind::HsDeclP->Bool
isFunBind (Dec (HsFunBind loc matches))=True
isFunBind _ =False

--returns True if a declaration is a pattern binding.
isPatBind::HsDeclP->Bool
isPatBind (Dec (HsPatBind _ _ _ _))=True
isPatBind _=False

--returns True if a declaration is a pattern binding which only defines a variable value.
isSimplePatBind::HsDeclP->Bool
isSimplePatBind decl=case decl of
     Dec (HsPatBind _ p _ _)->patToPName p /=defaultPN
     _ ->False

--returns True if a declaration is a pattern binding but not a simple one.
isComplexPatBind::HsDeclP->Bool
isComplexPatBind decl=case decl of
     Dec (HsPatBind _ p _ _)->patToPName p ==defaultPN
     _ -> False

--returns True if a declaration is a function/pattern definition.
isFunOrPatBind::HsDeclP->Bool
isFunOrPatBind decl=isFunBind decl || isPatBind decl

--returns True if a declaration is a Class declaration.
isClassDecl (Dec (HsClassDecl _ _ _ _ _)) = True
isClassDecl _ = False

--returns True if a declaration is a Class instance declaration.
isInstDecl (Dec (HsInstDecl _ _ _ _ _)) = True
isInstDecl _ = False
        
--returns True if a statement is the last statement.
isLast::HsStmtP->Bool
isLast (HsLast e)=True
isLast _=False

--returns the expression included in the last statement.
expInLast::HsStmtP->Maybe HsExpP 
expInLast (HsLast e)=Just e
expInLast _=Nothing

-- returns True if a function is directly recursive.
isDirectRecursiveDef::HsDeclP->Bool
isDirectRecursiveDef (Dec (HsFunBind loc ms)) 
   = any isUsedInDef ms 
  where 
   isUsedInDef (HsMatch loc1 fun pats rhs ds)
     = findPName (pNTtoPN fun) rhs
isDirectRecursiveDef _ = False


--add a qualifier to a PName if it is unqualified.
qualifyPName::HsName.ModuleName->PName->PName
qualifyPName qual pn 
 = case pn of 
      PN (UnQual n) ty -> PN (Qual qual n ) ty
      _                -> pn

--removed the qualifier from the specified PNames.
rmQualifier::((MonadState (([PosToken], Bool), t1) m),Term t)
             =>[PName]  -- those identifiers whose qualifier should be removed.
               ->t->m t
rmQualifier pns t 
  = applyTP (full_tdTP (adhocTP idTP rename )) t
   where 
     rename pnt@(PNT  pn@(PN (Qual modName  s) l) ty loc@(N (Just (SrcLoc fileName _ row col))))
       | elem pn pns
       = do replaceToks' (row,col) (row,col) [mkToken Varid (row,col) s]
            return (PNT (PN (UnQual s) l) ty loc)
     rename x = return  x


--Show a list of entities, the parameter f is a function that specifies how to format individual pns.
showPns::(Eq t, Term t)=>(t->String)->[t]->String
showPns f [] = ""
showPns f (pn:pns) = if pns==[] then f pn
                                else (f pn ++ "," ++ showPns f pns)

--show a PName ,say pn, in a format like: 'pn'(at row:r, col: c).
showPNwithLoc::PName->String
showPNwithLoc pn
  = let (SrcLoc _ _ r c)=srcLoc pn
    in  " '"++pNtoName pn++"'" ++"(at row:"++show r ++ ",col:" ++ show c ++")"


----------------------------------------------------------------------------------
-- some default values
defaultPN=PN (UnQual "unknown") (G (PlainModule "unknown") "--" (N Nothing)) :: PName

defaultPNT=PNT defaultPN Value  (N Nothing) :: PNT 

defaultModName = PlainModule "unknown"

defaultExp=Exp (HsId (HsVar defaultPNT))

defaultPat=Pat (HsPId (HsVar defaultPNT))

------------------------------------------------------------------------------------
--Returns True if two pnts are the same.
samePNT::PNT->PNT->Bool
samePNT (PNT pname1 ty1 (N loc1)) (PNT pname2 ty2 (N loc2)) = pname1==pname2 && loc1==loc2
                         
--Fetch the PName from a PNT.
pNTtoPN :: PNT->PName
pNTtoPN (PNT pname _ _)=pname

--Fetch the name from a PName. This function does not take the qualfier into account.
pNtoName::PName->String
pNtoName (PN (UnQual i) orig)=i
pNtoName (PN (Qual modName i) orig)=i   

--Fetch the name from a PNT.This function does not take the qualfier into account.
pNTtoName::PNT->String
pNTtoName=pNtoName.pNTtoPN
----------------------------------------------------------------------------------
-- fetch the module name from an identifier.
class (Term t) => HasModName t where
  
    hasModName :: t->Maybe (HsName.ModuleName)

instance HasModName PNT  where

    hasModName (PNT (PN _ (G modName s1 loc)) _ _)=Just modName
    hasModName _ =Nothing   

instance HasModName PName where
  
    hasModName (PN _ (G modName s1 loc))=Just modName
    hasModName _ =Nothing

----------------------------------------------------------------------
-- compose a PNT form a String
idToPNT::String->PNT
idToPNT id =(PNT (PN (UnQual id) (G (PlainModule "unknown") id
                 (N (Just loc0)))) Value (N (Just loc0)))

-- compose a PNT from a PName and the PName's name space info.
pNameToPNT::PName->IdTy PId->PNT
pNameToPNT pname ty =  PNT pname ty (N (Just loc0))

{-if an expression consists of only one identifers then returns this identifier in PNT format,
  otherwise, returns the default PNT. -}
expToPNT::HsExpP->PNT
expToPNT (Exp (HsId (HsVar pnt)))=pnt 
expToPNT (Exp (HsParen e))=expToPNT e 
expToPNT _ =defaultPNT

{-if an expression consists of only one identifers then returns this identifier in PName
  format, otherwise, returns the default PName. -}
expToPName::HsExpP->PName
expToPName =pNTtoPN.expToPNT

-- compose an expression from a String.
idToExp ::String ->HsExpP
idToExp name
    =Exp (HsId (HsVar (PNT (PN (UnQual name) (S loc0)) Value (N (Just loc0)))))

--compose an expression from a pName.
pNameToExp::PName->HsExpP
pNameToExp pn =Exp (HsId (HsVar (PNT pn  Value (N (Just loc0)))))

{-if a pattern consists of only one identifers then returns this identifier in PNT format,
  otherwise, returns the default PNT. -}
patToPNT::HsPatP->PNT
patToPNT (Pat (HsPId (HsVar pnt)))= pnt
patToPNT (Pat (HsPParen p))=patToPNT p
patToPNT _=defaultPNT

{-if a pattern consists of only one identifers then returns this identifier in PName format,
  otherwise, returns the default PName. -}
patToPName::HsPatP->PName
patToPName=pNTtoPN.patToPNT

-- compose a pattern from a String.
idToPat name
    =Pat (HsPId (HsVar (PNT (PN (UnQual name) (S loc0)) Value (N (Just loc0)))))

-- compose a pattern from a pName.
pNameToPat :: PName -> HsPatP
pNameToPat pname
    =let loc=srcLoc pname
     in (Pat (HsPId (HsVar (PNT pname Value (N (Just loc))))))
---------------------------------------------------------------------------
{-Create a new name base on the old name. Suppose the old name is 'f', then 
  the new name would be like 'f_i' where 'i' is an integer.
-}

mkNewName::String->[String]->Int->String
mkNewName oldName fds init
  =let newName=if init==0 then oldName
                          else oldName++"_"++ show init
   in if elem newName fds
        then mkNewName oldName fds (init+1)
        else newName 

--returns the identifier's defining location.
defineLoc::PNT->SrcLoc
defineLoc (PNT pname _ _) = srcLoc pname

-- returns the identifier's source location.
useLoc::PNT->SrcLoc
useLoc (PNT pname _ (N (Just loc))) = loc
useLoc (PNT _ _ _ )                 = loc0

-- returns True if the pnt is used in the rhs if a function/pattern binding.
pNTinRhsUseLoc::(Term t)=>PNT->t->Bool
pNTinRhsUseLoc pnt t= useLoc pnt /= defineLoc pnt  && not (findPntInLhs pnt t)
  where
    findPntInLhs pnt
     = (fromMaybe False).(applyTU (once_tdTU (failTU `adhocTU` inMatch
                                                     `adhocTU` inDecl)))
     where
      inMatch ((HsMatch loc1 name pats rhs ds)::HsMatchP)
         | isJust (find (samePNT pnt) [name]) = Just True
      inMatch _ =Nothing

      inDecl ((Dec (HsTypeSig loc is c tp))::HsDeclP)
        |isJust (find (samePNT pnt) is)   = Just True
      inDecl _ =Nothing    

--returns True is the identifier is unqualifily used in a given syntax phrase t.
isUnqualifiedUsed::(Term t)=>String->t->Bool
isUnqualifiedUsed name t
   =(fromMaybe False) (applyTU (once_tdTU (failTU `adhocTU` worker)) t)
      where
         worker (pnt::PNT)
           |pNTtoName pnt ==name && pNTinRhsUseLoc pnt t && not (isQualifiedPN (pNTtoPN pnt)) 
          = Just True
         worker _ =Nothing


{- Find the identifier (in PNT format) whose start position is (row,col) in the
   file specified by fileName, and returns defaultPNT is such a identifier does not exist.
-}
locToPNT::(Term t)=>String->Int->Int->t->PNT
locToPNT  fileName row col 
  =(fromMaybe defaultPNT). applyTU (once_buTU (failTU `adhocTU` worker))
     where 
        worker pnt@(PNT pname ty (N (Just (SrcLoc fileName1 _ row1 col1))))
           |fileName1==fileName && row1==row && col1==col =Just pnt
        worker _ =Nothing 

{- Find the identifier (in PName format) whose start position is (row,col) in the
   file specified by fileName, and returns defaultPN is such a identifier does not exist.
-}
locToPName::(Term t)=>String->Int->Int->t->PName
locToPName fileName row col =pNTtoPN.(locToPNT fileName row col)


{-Given a syntax phrase t, find the largest leftmost expression in t whose start&end position
  should be in the range specified by beginPos & endPos. -}

locToExp::(Term t)=>[PosToken]->SimpPos->SimpPos->t->HsExpP
locToExp toks beginPos endPos t
  = fromMaybe defaultExp (applyTU (once_tdTU (failTU `adhocTU` exp)) t)
  where
   exp (e::HsExpP)
     |inScope e =Just e
   exp _ =Nothing                     
   
   inScope e = let (startLoc, endLoc)=getStartEndLoc toks e
               in (startLoc >= beginPos) && (startLoc<= endPos) && (endLoc>= beginPos) && (endLoc  <= endPos)
  


pnToEnt pn = EntE (Var (pNameToPNT pn Value))
---------------------------------------------------------------------------------------
--Collect all the PNames in a given syntax phrase.     
pNamesIn::(Term t)=> t->[PName]
pNamesIn=(nub.ghead "pNamesIn").applyTU (full_tdTU (constTU [] `adhocTU` inPnt)) 
  where 
     inPnt (PNT pname ty loc) = return [pname]

--Collect all the PNTs in a given syntax phrase.
pNTsIn ::(Term t)=>t->[PNT]
pNTsIn =(nub.ghead "pNTsIn").applyTU (full_tdTU (constTU [] `adhocTU` inPnt))
   where
     inPnt pnt@(PNT _  _ _) = return [pnt]


--Find those declarations(function/pattern binding and type signature) which define pns-
--incTypeSig indicates whether the corresponding type signature will be included.
definingDecls::[PName]->[HsDeclP]->Bool->Bool->[HsDeclP]
definingDecls pns ds incTypeSig recursive=concatMap defines ds  
  where
   defines decl
     =if recursive
        then ghead "defines" $ applyTU (stop_tdTU (failTU `adhocTU` inDecl)) decl
        else defines' decl
     where
      inDecl (d::HsDeclP)
        |defines' d /=[] =return $ defines' d
      inDecl _=mzero 

      defines' decl@(Dec (HsFunBind _ ((HsMatch _ (PNT pname _ _) _ _ _):ms))) 
        |isJust (find (==pname) pns) = [decl]
      defines' decl@(Dec (HsPatBind loc p rhs ds))    ---CONSIDER AGAIN----
        |(pNamesIn p) `intersect` pns /=[] = [decl]
      defines' decl@(Dec (HsTypeSig loc is c tp))     --handle cases like  a,b::Int 
        |(map pNTtoPN is) `intersect` pns /=[]
        =if incTypeSig 
           then [(Dec (HsTypeSig loc (filter (\x->isJust (find (==pNTtoPN x) pns)) is) c tp))]
           else []
      defines' _ =[]   

--Find those declarations(function/pattern binding and type signature) which define pn-
--splitTypeSig indicates whether the corresponding type signature will be splited.
definingDecls1::[PName]->[HsDeclP]->Bool->[HsDeclP]
definingDecls1 pns ds incTypeSig=concatMap (defines pns) ds 
      where 
       defines pn decl@(Dec (HsFunBind loc ((HsMatch loc1 (PNT pname ty loc2) pats rhs ds):ms)))
          | isJust (find (==pname) pns)=[decl]
       defines pn decl@(Dec (HsPatBind loc p rhs ds))    ---CONSIDER AGAIN----
          |(pNamesIn p) `intersect` pns /=[]=[decl]
       defines pn decl@(Dec (HsTypeSig loc is c tp)) --handle cases like  a,b::Int 
          |(map pNTtoPN is) `intersect` pns /=[]
          =if incTypeSig then [(Dec (HsTypeSig loc (filter (\x->isJust (find (==pNTtoPN x) pns)) is) c tp))]
                           else [decl]
       defines pn decl=[]   


--`define` returns True if the  function/pattern binding defines pn, otherwise returns False.
defines::PName->HsDeclP->Bool
defines pn decl@(Dec (HsFunBind loc ((HsMatch loc1 (PNT pname ty loc2) pats rhs ds):ms))) 
 = pname == pn
defines pn decl@(Dec (HsPatBind loc p rhs ds)) = elem pn (pNamesIn p)
defines _ _= False

--`definesTypeSig` returns True if the decl defines the type signature of pn.
definesTypeSig pn (Dec (HsTypeSig loc is c tp))=elem pn (map pNTtoPN is)  
definesTypeSig _  _ =False

-- returns the list of PNames defined by a function/pattern binding.
definedNames::HsDeclP->[PName]
definedNames (Dec (HsFunBind _ ((HsMatch _ (PNT pname _ _) _ _ _):_))) =[pname]
definedNames (Dec (HsPatBind _ p _ _)) =pNamesIn p
definedNames _=[] 


{-`divideDecls` divides a declaration list(ds) into three parts (before, parent, after) according 
  to the `pnt`, where 'parent' is the first decl containing 'pnt', 'before' are those decls 
  before 'parent' and 'after' are those decls after 'parent'. -}

divideDecls::[HsDeclP]->PNT->([HsDeclP],[HsDeclP],[HsDeclP])
divideDecls ds pnt
  = let (before,after)=break (\x->findPNT pnt x) ds
    in if (after/=[])
         then (before, [head after], tail after)
         else (ds,[],[])

{- hasFreeVars returns True if there are free variables in Syntax phrase t, otherwise
   it returns False. -}
hasFreeVars::(Term t)=>t->Bool
hasFreeVars t = fromMaybe False (do (f,_)<-hsFreeAndDeclared t
                                    if f/=[] then Just True
                                             else Nothing) 

-- removeTypeSigs removes the signature declaraion for pn from the decl list.
removeTypeSig ::PName->[HsDeclP]->[HsDeclP]
removeTypeSig pn decls=concatMap (removeTypeSig' pn) decls
      where removeTypeSig' pn sig@(Dec (HsTypeSig loc is c tp))
             =if definesTypeSig pn sig && length is==1 
                 then []
                 else [Dec (HsTypeSig loc (filter (\x-> (pNTtoPN x)/=pn) is) c tp)]
            removeTypeSig' pn x=[x]   


{-remove source location information in the syntax tree, that is to replace all
  source locations by default location: loc0 -}       
rmLocs :: (Term t)=> t->t 
rmLocs t =runIdentity (applyTP (full_tdTP (idTP `adhocTP` exp
                                                `adhocTP` pnt
                                                `adhocTP` alt
                                                `adhocTP` lit)) t) 
   where 
         exp ((Exp (HsNegApp loc e)) ::HsExpP)=return (Exp (HsNegApp loc0 e))
         exp (Exp (HsExpTypeSig loc e c t))=return (Exp (HsExpTypeSig loc0 e c t))
         exp x=return x 

         alt ((HsAlt loc p e ds)::HsAltP)=return (HsAlt loc0 p e ds)

         lit (HsInt loc int) = return (HsInt loc0 int)
         lit (HsFrac loc rat)= return (HsFrac loc0 rat)

         pnt (PNT pname ty _)= return (PNT pname ty (N (Just loc0)))

{- toRelativeLocs changes the absolute define ocations of local variables to relative ones,
   so that we can compare equality between expressions via alpha-renaming.
-}
toRelativeLocs::(Term t)=>t->t
toRelativeLocs e = runIdentity (applyTP (full_tdTP (idTP `adhocTP` inLoc)) e)
  where
    inLoc (SrcLoc f c row col)
      | elem (row,col) defLocs
          = let index=fromJust (elemIndex (row,col) defLocs) + 1 
            in return (SrcLoc f c index index)
    inLoc loc = return loc

    defLocs= ((nub.ghead "toRelativeLoc").applyTU (full_tdTU (constTU [] `adhocTU` inPnt))) e
        where
         inPnt pnt@(PNT pn ty loc)
            |defineLoc pnt == useLoc pnt= return [(\(SrcLoc _ _ r c)->(r,c)) (srcLoc pn)]
         inPnt _ = return []
     
------------------------------------------------------------------------------------------ 
--replace the name (and qualifier if specified) by a new name (and qualifier) in a PName.
replaceNameInPN::Maybe HsName.ModuleName->  -- the new qualifier
                 PName ->                   -- the old PName
                 String->                   -- the new name 
                 PName
replaceNameInPN qualifier (PN (UnQual s)(S loc))  newName
  = if isJust qualifier then (PN (Qual (fromJust qualifier) newName) (S loc))
                        else (PN (UnQual newName) (S loc)) 
replaceNameInPN qualifier (PN (Qual modName  s)(S loc))  newName
  = if isJust qualifier  then (PN (Qual (fromJust qualifier) newName)(S loc))
                         else (PN (Qual modName newName) (S loc))
replaceNameInPN qualifier (PN (UnQual s) (G modName s1 loc))  newName
  = if isJust qualifier then (PN (Qual (fromJust qualifier)  newName) (G modName newName loc))
                        else (PN (UnQual newName) (G modName newName loc)) 
replaceNameInPN qualifier (PN (Qual modName s) (G modName1 s1 loc))  newName
  =if isJust qualifier then (PN (Qual (fromJust qualifier) newName) (G modName1 newName loc)) 
                       else (PN (Qual modName newName) (G modName1 newName loc))

--change a PName into a String
pNameToStr::PName->String
pNameToStr (PN (UnQual s) _) =s
pNameToStr (PN (Qual (PlainModule qualifier) s) _)=qualifier ++ "."++ s

{- renamePN renames every occurrences of an identifier in t with a new name.
   if the parameter `updateToks` is True, it modifies both the AST and the token stream,
   otherwise only modify the AST.-}

renamePN::((MonadState (([PosToken], Bool), t1) m),Term t)
           =>PName->    -- the identifier to be renamed.
             Maybe HsName.ModuleName->  -- the qualifer
             String->    -- the new name 
             Bool  ->    -- True means modifying the token stream as well.
             t ->        -- the syntax phrase
             m t  
renamePN oldPN qualifier newName updateToks t
  = applyTP (full_tdTP (adhocTP idTP rename)) t
  where
    rename  pnt@(PNT pn ty (N (Just (SrcLoc fileName c  row col))))
     | (pn ==oldPN) && (srcLoc oldPN == srcLoc pn)
     = do if updateToks  
           then  do ((toks,_),others)<-get                           
                    let toks'=replaceToks toks (row,col) (row,col)
                              [mkToken Varid  (row,col) (pNameToStr (replaceName pn  newName))]
                    put ((toks', modified),others)
                    return (PNT (replaceName pn newName) ty (N (Just (SrcLoc fileName c  row col))))
           else return (PNT (replaceName pn newName) ty (N (Just (SrcLoc fileName c  row col))))
      where 
        replaceName = if isJust qualifier && canBeQualified pnt t 
                        then replaceNameInPN qualifier
                        else replaceNameInPN Nothing       
    rename x = return x 
  
--canBeQualifed returns True if the occurrence of pnt can be qualified, otherwise it returns False.
canBeQualified::(Term t)=>PNT->t->Bool
canBeQualified pnt t
  = isTopLevelPNT pnt && pNTinRhsUseLoc pnt t && not (findPntInImp pnt t) 
  where 
    findPntInImp pnt 
      = (fromMaybe False).(applyTU (once_tdTU (failTU `adhocTU` inImp)))
      where 
       inImp ((HsImportDecl loc modName qual  as h)::HsImportDeclP)
        |findPNT pnt h = Just True
       inImp _ = Nothing
  
 
-- findPNT returns True if pnt exists in a given syntax phrase, otherwise it returns False.
findPNT::(Term t)=>PNT->t->Bool  
findPNT pnt 
  = (fromMaybe False).(applyTU (once_tdTU (failTU `adhocTU` worker)))
  where
    worker (pnt1::PNT)
      | samePNT pnt pnt1 =Just True
    worker _ =Nothing  

--findPName returns True if pn exists in a given syntax phrase, otherwise it returns False.
findPName::(Term t)=>PName->t->Bool
findPName pn 
  =(fromMaybe False).(applyTU (once_tdTU (failTU `adhocTU` worker)))
     where 
        worker (pn1::PName)
           |pn == pn1 && srcLoc pn == srcLoc pn1 = Just True 
        worker _ =Nothing 

--findPNames returns True if any names in pns exist in a given syntax phrase, otherwise it returns False.
findPNames::(Term t)=>[PName]->t->Bool 
findPNames pns 
   =(fromMaybe False).(applyTU (once_tdTU (failTU `adhocTU` worker)))
     where 
        worker (pn1::PName)
           |elem pn1 pns = Just True
        worker _ =Nothing  



----------------------------------------------------------------------------------------
{- autoRenameLocalVar checks whether variable pn is declared in the given syntax phrase,
   if so, it will rename pn by create a new name automatically. If the parameter 
   'updateToks' is True, the token stream will be updated, otherwise only the AST is updated. 
-}
autoRenameLocalVar::(MonadPlus m, (MonadState (([PosToken], Bool), t1) m), Term t)
                    =>Bool->     -- modify the token stream or not.  
                      PName->    -- the variable to be rename.
                      t->        -- the syntax phrase.
                      m t
autoRenameLocalVar updateToks pn 
  =applyTP (once_buTP (failTP `adhocTP` renameInMatch 
                              `adhocTP` renameInPat
                              `adhocTP` renameInExp
                              `adhocTP` renameInAlt
                              `adhocTP` renameInStmts))  
      where 
         renameInMatch (match::HsMatchP)
           |isDeclaredIn pn match=worker match
         renameInMatch _ =mzero
     
         renameInPat (pat::HsDeclP)
          |isDeclaredIn pn pat=worker pat                 
         renameInPat _ =mzero
     
         renameInExp (exp::HsExpP)
          |isDeclaredIn pn exp=worker exp                 
         renameInExp _ =mzero
 
         renameInAlt (alt::HsAltP)
          |isDeclaredIn pn alt=worker alt                 
         renameInAlt _ =mzero
       
         renameInStmts (stmt::HsStmtP)
          |isDeclaredIn pn stmt=worker stmt
         renameInStmts _=mzero
         
         worker t =do (f,d)<-freeAndDeclaredVblNames t
                      ds<-hsVisibleNames pn (declsIn t)
                      let newName=mkNewName (pNtoName pn) (nub (f `union` d `union` ds)) 1
                      if updateToks
                        then renamePN pn Nothing newName True t 
                        else renamePN pn Nothing newName False t     

-------------------------------------------------------------------------------------
{- addGuardsToRhs adds a guard expression to the rhs of a function/pattern definition.
   If a guard already exists in the rhs, the new guard will be added to the beginning 
   og the existing one.
-}

addGuardsToRhs::(MonadState (([PosToken], Bool), t1) m)=>
                RhsP->   -- the right hand side of the declaration
                HsExpP-> -- the guard expression to add
                m RhsP   -- the right hand side of the declaration with the new guard.
addGuardsToRhs (HsBody e) guardExp 
  = do ((toks,_), others) <-get
       let (startPos', _) = startEndLoc toks e
           (toks1,toks2) = break (\t->tokenPos t==startPos') toks
       let reversedToks1BeforeEqOrArrow = dropWhile (\t->not (isEqual t || isArrow t)) (reverse toks1) 
           eqOrArrowTok = ghead "addGuardsToRhs"  reversedToks1BeforeEqOrArrow
           startPos@(row,col)=tokenPos eqOrArrowTok
           toksBeforeEqOrArrow = takeWhile (\x->tokenRow x == row && tokenCol x < col)(tail reversedToks1BeforeEqOrArrow) 
           offset = lengthOfToks toksBeforeEqOrArrow
           newToken = mkToken Varid startPos ("|"++(render.ppi) guardExp++"\n"++replicate offset ' '++ tokenCon eqOrArrowTok)
       let toks' = replaceToks toks startPos startPos [newToken]      
       put ((toks',modified),others)      
       return $ HsGuard [(loc0, guardExp, e)]

addGuardsToRhs (HsGuard gs) guardExp
  = do newGuards <- mapM (addGuard guardExp) gs
       return (HsGuard newGuards)
   where 
   addGuard guardExp (loc, e1, e2)
     = do let newGuard = Exp (HsInfixApp guardExp (HsVar (idToPNT "&&")) e1)
          updateExpToks e1 newGuard 
          return (loc, newGuard, e2)


------------------------------------------------------------------------------------------------------
{--addParamsToDecls add parameters to a function name at both the definition site and it's call sites,
   Note this function only modify the AST, it does not modify the token stream.
   The token stream modification should be added later.
-}
addParamsToDecls::[HsDeclP]   -- a list of declarations where the function name can be defined and/or used.
                  ->PName     -- the function name
                  ->[PName]   -- the list of parameters to add
                  ->[HsDeclP] -- returns the modified list of declarations.

addParamsToDecls decls pn paramPNames
   = if (paramPNames/=[])
       then let decls'=addActualParamsToExps pn paramPNames decls
            in  addFormalParamsToPats paramPNames decls' 
       else decls 
  where 
   addActualParamsToExps pn paramPNames
     =runIdentity.applyTP (full_tdTP (idTP `adhocTP` worker))  
        where                   
          worker exp@(Exp (HsId (HsVar (PNT pname ty loc))))
           | pname==pn
           = do let exps=map pNameToExp paramPNames
                return (foldl addParamToExp exp exps)
          worker x =return x 

          addParamToExp  exp param=(Exp (HsApp exp param))
 
   addFormalParamsToPats paramPNames decls 
     = map (addParamToDecl (map pNameToPat paramPNames)) decls
     where   
     addParamToDecl params  (Dec (HsFunBind loc matches)) 
        =(Dec (HsFunBind loc (map(addParamtoMatch params) matches)))
        where 
         addParamtoMatch param (HsMatch loc  fun  pats rhs  decls) 
            =(HsMatch loc  fun  (param++pats)  rhs  decls)
     addParamToDecl params (Dec (HsPatBind loc p rhs ds))
          |patToPNT p/=defaultPNT =(Dec (HsFunBind loc [HsMatch loc (patToPNT p) params rhs ds]))
        -- add parameters in lambda style to pattern binding
        --PROBLEM : how about guard cases?
     addParamToDecl params (Dec (HsPatBind loc p (HsBody e) ds))
        =(Dec (HsPatBind loc p (HsBody (Exp (HsLambda params e))) ds)) 
     addParamToDecl params x=x 


   rmOneParamWithUpdToks pnt 
       =applyTP (stop_tdTP (failTP `adhocTP` inExp)) 
           where
             inExp (exp@(Exp (HsParen (Exp (HsApp e1 e2))))::HsExpP)
                |samePNT (expToPNT e1) pnt 
                 =do updateExpToks exp e1
                     return e1     
             inExp exp@(Exp (HsApp e1 e2))
              | samePNT (expToPNT e1) pnt
                 =do updateExpToks exp e1
                     return e1
             inExp  _=mzero

 --remove the first n parameters of pnt in expression 'exp' 
rmParams pnt n exp 
  = if n==0 then return exp
            else do exp'<-rmOneParam pnt exp
                    rmParams pnt (n-1) exp' 
   where 
         rmOneParam pnt= applyTP (stop_tdTP (failTP `adhocTP` inExp))
       
         inExp (exp@(Exp (HsParen (Exp (HsApp e1 e2))))::HsExpP)
          ---dfd
           |samePNT (expToPNT e1) pnt 
            =do updateExpToks exp e1
                return e1     
         inExp exp@(Exp (HsApp e1 e2))
           | samePNT (expToPNT e1) pnt
            =do updateExpToks exp e1
                return e1
         inExp  _=mzero

         updateExpToks exp e1 
           = do ((toks,_),others)<-get     --handle the case like '(fun x) => fun "
                let (startPos,endPos)=getStartEndLoc toks exp
                    toks'=replaceToks toks startPos endPos $ getToks (getStartEndLoc toks e1) toks
                put ((toks',modified),others)
                return e1   



{-A simple function binding satisfies : 1. all parameters are variables
                                        2. only one match(equation)
                                        3. The rhs of the match is not in guard style.
  that is:
   HsFunBind SrcLoc ((HsMatch SrcLoc i [var] (HsBody e) ds):[]) ds

  If a function binding is not a simple function binding, then convert it into a simple binding 
  using Case or IfThenElse expressions like this:
    case1: there are multi matches => case expression
    case2: there is only one match, however the parameters are not simple variables =>case expression.
    case3: there is only one match and the parameters are all simple variables, however there is a guard
           in Rhs => If then else

  In case of pattern binding: if there is guard in its Rhs, then convert it into IfThenElse style.
                              
-}
       
simplifyDecl decl
      |isFunBind decl =if (multiMatches decl) || (singleMatchWithComplexParams decl)
                           then matchesToCase decl
                           else return (guardToIfThenElse decl)
      |isPatBind decl=return (guardToIfThenElse  decl)
   where

      multiMatches (Dec (HsFunBind loc matches))=length matches>1
      multiMatches _ = False 

      singleMatchWithComplexParams (Dec (HsFunBind loc matches@((HsMatch loc1 pnt pats rhs ds):ms)))
            =length matches==1 && any (==defaultPN) (map patToPName pats)
      singleMatchWithComplexParams _ =False

      --convert a multi-match function declaration into a single-match declration using case expression.
      matchesToCase decl@(Dec (HsFunBind loc matches@((HsMatch loc1 pnt pats rhs ds):ms)))
        =do params<-mkNewParamPNames (length pats)
            exp<-pNamesToExp params
            return (Dec (HsFunBind loc [(HsMatch loc1 pnt (map pNameToPat params)
                      (HsBody (Exp (HsCase exp (map matchToAlt matches)))) [])]))

      --make n new parameters like [x_0,x_1, ...,x_n]
      mkNewParamPNames n=mkNewParamPNames' n []
              where mkNewParamPNames' n pNames
                         =if n==0 then return pNames
                                     else do let pn'= PN (UnQual  ("x_"++show (n-1))) (S loc0)
                                             mkNewParamPNames' (n-1) (pn':pNames)
                                        
      matchToAlt ((HsMatch loc1 pnt pats rhs ds)::HsMatchP)=HsAlt loc0 (listToTuple pats) rhs ds
        where
         listToTuple pats=if (length pats)==1 then head pats   --no problem with head
                                              else (Pat (HsPTuple pats))

      pNamesToExp pns@(p:ps)=if ps==[] then return $ pNameToExp p
                                        else  do let exp'=map pNameToExp pns
                                                 return (Exp (HsTuple exp')) 
     
      guardToIfThenElse decl= case decl of
          (Dec (HsPatBind loc p g@(HsGuard gs) ds))->(Dec (HsPatBind loc p (rmGuard g) ds))
          (Dec (HsFunBind loc ((HsMatch loc1 pnt pats  g@(HsGuard gs) ds):[]))) ->
                            (Dec (HsFunBind loc ((HsMatch loc1 pnt pats (rmGuard g) ds):[])))
          _ ->decl
           
          where
           rmGuard ((HsGuard gs)::RhsP)
             = let (_,e1,e2)=glast "guardToIfThenElse" gs
               in  if ((pNtoName.expToPName) e1)=="otherwise" 
                   then  HsBody (foldl mkIfThenElse e2 (tail(reverse gs)))
                   else  HsBody (foldl mkIfThenElse defaultElse (reverse gs)) 
           
           mkIfThenElse e (_,e1, e2)=(Exp (HsIf e1 e2 e)) 

           defaultElse=(Exp (HsApp (Exp (HsId (HsVar (PNT (PN (UnQual "error") (G (PlainModule "Prelude") "error" 
                        (N (Just loc0)))) Value (N (Just loc0)))))) (Exp (HsLit loc0 (HsString "UnMatched Pattern")))))
            

-----------------------------------------------------------------------------------------
{- `hsDataConstrs` collects those data constructors that are used or declared
    in a module. In the returned result, the first list contains those data
    constructors that are declared in other modules but are used in the current
    module, whereas the second list contains those data constructors that are
    declared in the current module.
-}
hsDataConstrs::Term t=>HsName.ModuleName->t->([PName],[PName])
hsDataConstrs modName  
  = ghead "hsDataConstrs". (applyTU (stop_tdTU (failTU `adhocTU` pnt)))  
  where
    pnt (PNT pname (ConstrOf _  _) _)
      = if hasModName pname==Just modName 
          then return ([],[pname])
          else return ([pname],[])
    pnt _ = mzero


{-`hsTypeConstrAndClasses` collects those type constructors and class names that are
   used or declared in a module. In the retured result, the first list contains those 
   type constructor/classes which are declared in other modules but are used
   in the current module, whereas the second list contains those type constructor/classes
   that are declaraed in the current module.
-}
hsTypeConstrsAndClasses::Term t=>HsName.ModuleName->t->([PName],[PName])
hsTypeConstrsAndClasses modName
  = ghead "hsTypeConstrAndClasses".(applyTU (stop_tdTU (failTU `adhocTU` pnt))) 
  where 
    pnt (PNT (PN i (G  modName1 id loc)) (Type _) _)
      = if modName == modName1
                     then return ([],[(PN i (G  modName id loc))])
                     else return ([(PN i (G  modName id loc))], [])
    pnt (PNT pname (Class _) _)=if hasModName pname==Just modName 
                                 then return ([],[pname])
                                 else return ([pname],[])
    pnt _ =mzero


{-`hsTypeVbls` collects those type variables that are declared in a given syntax phrase.
  In the returned result, the first list should be empty.
-}
hsTypeVbls::(Term t) => t -> ([PName],[PName])
hsTypeVbls =ghead "hsTypeVbls".(applyTU (stop_tdTU (failTU `adhocTU` pnt))) 
  where 
    pnt (PNT (PN i (S loc)) (Type _) _) = return ([], [(PN i (S loc))])
    pnt _ =mzero


{-`hsClassMembers` collects those class instances which are used or declared in 
   a module. In the retured result, the first list contains those class instances
   which are declared in other modules, but are used in the current module, wheras
   the second list contains those class instances that are declaraed in the 
   current module.
-}
hsClassMembers::Term t => String->HsName.ModuleName->t->([PName],[PName])
hsClassMembers className modName 
    = ghead "hsClassMembers". (applyTU (stop_tdTU (failTU `adhocTU` pnt))) 
         where
            pnt(PNT pname (MethodOf i _) _) -- Claus
                | pNtoId i==className
                  = if hasModName pname == Just modName 
                      then return ([],[pname])
                      else return ([pname],[])
            pnt _ = mzero   
            
            pNtoId :: PN (HsName.Id) ->String
            pNtoId (PN i orig)=i

------------------------------------------------------------------------------------------
{-hsFreeAndDeclared collects all the free and declared variables in a given syntax phrase t.
  The collected identifiers are in PName format. The first list in the returned result contains
  the free identifiers while the second list contains the declared identifiers.
-}
hsFreeAndDeclared:: (Term t, MonadPlus m)=> t-> m ([PName],[PName])
hsFreeAndDeclared t=do (f,d)<-hsFreeAndDeclared' t
                       return (nub f, nub d)
   where 
          hsFreeAndDeclared'=applyTU (stop_tdTU (failTU  `adhocTU` exp
                                                         `adhocTU` pat
                                                         `adhocTU` match
                                                         `adhocTU` patBind
                                                         `adhocTU` alt
                                                         `adhocTU` decls
                                                         `adhocTU` stmts
                                                         `adhocTU` recDecl))  
                          
          exp (Exp (HsId (HsVar (PNT pn _ _))))=return ([pn],[])
          exp (Exp (HsId (HsCon (PNT pn _ _))))=return ([pn],[])
          exp (Exp (HsInfixApp e1 (HsVar (PNT pn _ _)) e2))
              =addFree pn (hsFreeAndDeclared [e1,e2])
          exp (Exp (HsLambda pats body))
              = do (pf,pd) <-hsFreeAndDeclared pats
                   (bf,_) <-hsFreeAndDeclared body
                   return ((bf `union` pf) \\ pd, [])
          exp (Exp (HsLet decls exp))
              = do (df,dd)<- hsFreeAndDeclared decls
                   (ef,_)<- hsFreeAndDeclared exp 
                   return ((df `union` (ef \\ dd)),[])
          exp (Exp (HsRecConstr (PNT pn _ _) e))
               =addFree  pn  (hsFreeAndDeclared e)   --Need Testing
          exp (Exp (HsAsPat (PNT pn _ _) e))
              =addFree  pn  (hsFreeAndDeclared e)  
          exp _ = mzero

          
          pat (Pat (HsPId (HsVar (PNT pn _ _))))=return ([],[pn])
          pat (Pat (HsPInfixApp p1 (HsVar (PNT pn _ _)) p2))=addFree pn (hsFreeAndDeclared [p1,p2])
          pat (Pat (HsPApp (PNT pn _ _) pats))=addFree pn (hsFreeAndDeclared pats)
          pat (Pat (HsPRec (PNT pn _ _) fields))=addFree pn (hsFreeAndDeclared fields)
          pat _ =mzero
                               

          match ((HsMatch _ (PNT fun _ _)  pats rhs  decls)::HsMatchP)
            = do (pf,pd) <- hsFreeAndDeclared pats
                 (rf,rd) <- hsFreeAndDeclared rhs
                 (df,dd) <- hsFreeAndDeclared decls
                 return ((pf `union` ((rf `union` df) \\ (dd `union` pd `union` [fun]))),[fun])

         -------Added by Huiqing Li-------------------------------------------------------------------

          patBind ((Dec (HsPatBind _ pat (HsBody rhs) decls))::HsDeclP)
             =do (pf,pd) <- hsFreeAndDeclared pat
                 (rf,rd) <- hsFreeAndDeclared rhs
                 (df,dd) <- hsFreeAndDeclared decls
                 return (pf `union` ((rf `union` df) \\(dd `union` pd)),pd)
          patBind _=mzero
         ------------------------------------------------------------------------------------------- 

          alt ((HsAlt _ pat exp decls)::(HsAlt (HsExpP) (HsPatP) [HsDeclP]))
             = do (pf,pd) <- hsFreeAndDeclared pat
                  (ef,ed) <- hsFreeAndDeclared exp
                  (df,dd) <- hsFreeAndDeclared decls
                  return (pf `union` (((ef \\ dd) `union` df) \\ pd),[])


          decls (ds :: [HsDeclP])
             =do (f,d) <-hsFreeAndDeclaredList ds
                 return (f\\d,d)
          
          stmts ((HsGenerator _ pat exp stmts) :: HsStmt (HsExpP) (HsPatP) [HsDeclP]) -- Claus
             =do (pf,pd) <-hsFreeAndDeclared pat
                 (ef,ed) <-hsFreeAndDeclared exp
                 (sf,sd) <-hsFreeAndDeclared stmts
                 return (pf `union` ef `union` (sf\\pd),pd)

          stmts ((HsLetStmt decls stmts) :: HsStmt (HsExpP) (HsPatP) [HsDeclP])
             =do (df,dd) <-hsFreeAndDeclared decls
                 (sf,sd) <-hsFreeAndDeclared stmts
                 return (df `union` (sf \\dd),[])
          stmts _ =mzero

          recDecl ((HsRecDecl _ _ _ _ is) :: HsConDeclI PNT (HsTypeI PNT) [HsTypeI PNT])
                =do let d=map pNTtoPN $ concatMap fst is
                    return ([],d)
          recDecl _ =mzero
            
       
          addFree free mfd=do (f,d)<-mfd
                              return ([free] `union` f, d)

          hsFreeAndDeclaredList l=do fds<-mapM hsFreeAndDeclared l
                                     return (foldr union [] (map fst fds),
                                             foldr union [] (map snd fds))
 

instance (Monoid a, Monoid b) => Monoid (a,b) where
   mappend (a,b) (a',b') = (mappend a a', mappend b b')
   mempty                = (mempty, mempty)

-- same as `hsFreeAndDeclared` except that the returned identifiers are in a String format.           
hsFreeAndDeclaredNames::(Term t, MonadPlus m)=> t->m([String],[String])
hsFreeAndDeclaredNames t =do (f1,d1)<-hsFreeAndDeclared t
                             return ((nub.map pNtoName) f1, (nub.map pNtoName) d1)

-----------------------------------------------------------------------------------------
{- The class method `freeAndDeclaredVbls` is different from `hsFreeAndDeclared` in that:
   given an syntax phrase t, `freeAndDeclaredVbls` returns not only the declared variables
   that are visible from outside of t, but also those declared variables that are visible
   to the main expression inside t.
-}

class (Term t)=>FreeAndDeclaredVbls t where

   freeAndDeclaredVbls :: (MonadPlus m)=>t->m ([PName],[PName])

instance FreeAndDeclaredVbls HsMatchP where 
    freeAndDeclaredVbls (HsMatch loc1 (PNT fun _ _) pats rhs ds) 
     = do(pf, pd)<-hsFreeAndDeclared pats
         (rf, rd)<-hsFreeAndDeclared rhs
         (df, dd)<-hsFreeAndDeclared ds
         return ((pf `union` ((rf `union` df) \\ (dd `union` pd `union` [fun]))), 
                 (pd `union` rd `union` dd `union` [fun]))

instance FreeAndDeclaredVbls HsDeclP where 
   freeAndDeclaredVbls (Dec (HsPatBind loc p rhs ds)) 
    = do (pf, pd)<-hsFreeAndDeclared p
         (rf, rd)<-hsFreeAndDeclared rhs
         (df, dd)<-hsFreeAndDeclared ds 
         return (pf `union` ((rf `union` df) \\ (dd `union` pd)),
                (pd `union` rd `union` dd))

   freeAndDeclaredVbls (Dec (HsFunBind loc matches))
      =do fds <-mapM freeAndDeclaredVbls matches
          return (concatMap fst fds, concatMap snd fds)  
   
   freeAndDeclaredVbls _=return ([],[]) 


instance FreeAndDeclaredVbls HsModuleP where
   freeAndDeclaredVbls (HsModule loc modName exps imps ds)
      =hsFreeAndDeclared ds  

instance FreeAndDeclaredVbls [HsDeclP] where
   freeAndDeclaredVbls decls=hsFreeAndDeclared decls 

instance FreeAndDeclaredVbls HsExpP where  

      freeAndDeclaredVbls (Exp (HsLet decls exp))
              = do (df,dd)<- hsFreeAndDeclared decls
                   (ef,_)<- hsFreeAndDeclared exp 
                   return ((df `union` (ef \\ dd)),dd)
      freeAndDeclaredVbls  (Exp (HsLambda pats body))
               = do (pf,pd) <-hsFreeAndDeclared pats
                    (bf,_) <-hsFreeAndDeclared body
                    return ((bf `union` pf) \\ pd, pd)      
      freeAndDeclaredVbls _ = return ([],[])

instance FreeAndDeclaredVbls HsAltP where
      
   freeAndDeclaredVbls (HsAlt _ pat exp decls)
             = do (pf,pd) <- hsFreeAndDeclared pat
                  (ef,ed) <- hsFreeAndDeclared exp
                  (df,dd) <- hsFreeAndDeclared decls
                  return (pf `union` (((ef \\ dd) `union` df) \\ pd),pd `union` dd)

instance FreeAndDeclaredVbls HsStmtP where
      freeAndDeclaredVbls (HsLetStmt decls stmts) 
           =do (df,dd) <-hsFreeAndDeclared decls
               (sf,sd) <-hsFreeAndDeclared stmts
               return (df `union` (sf \\dd),dd)

      freeAndDeclaredVbls (HsGenerator _ pat exp stmts) -- Claus
             =do (pf,pd) <-hsFreeAndDeclared pat
                 (ef,ed) <-hsFreeAndDeclared exp
                 (sf,sd) <-hsFreeAndDeclared stmts
                 return (pf `union` ef `union` (sf\\pd),pd)
     
      freeAndDeclaredVbls _ =return ([],[])    
     
--Same as `freeAndDeclaredVbls` except that the returned identifiers are in String format.
freeAndDeclaredVblNames::(FreeAndDeclaredVbls t,MonadPlus m)=>t->m ([String],[String])
freeAndDeclaredVblNames t =do (f,d)<-freeAndDeclaredVbls t
                              return ((nub.map pNtoName) f, (nub.map pNtoName) d)

------------------------------------------------------------------------------------------
--Same as `hsVisibleVbls' excepte that the returned identifiers are in String format.
hsVisibleNames e t =do d<-hsVisibleVbls e t
                       return ((nub.map pNtoName) d)
 
{-Given a syntax phrase e and t, if e is part of t, then returns those vairables(in PName format)
  which are declared in t and are accessible to e, otherwise returns [] -} 
hsVisibleVbls e =applyTU (full_tdTU (constTU [] `adhocTU` mod 
                                                `adhocTU` exp
                                                `adhocTU` match
                                                `adhocTU` patBind
                                                `adhocTU` alt
                                                `adhocTU` stmts))
      where         
          mod ((HsModule loc modName exps imps decls)::HsModuleP)
            |findEntity e decls
           =do (df,dd)<-hsFreeAndDeclared decls
               return dd
          mod _=return []
                                                             
          exp ((Exp (HsLambda pats body))::HsExpP)
            |findEntity e body
             = do (pf,pd) <-hsFreeAndDeclared pats
                  return pd         

          exp (Exp (HsLet decls e1))
             |findEntity e e1 || findEntity e decls
             = do (df,dd)<- hsFreeAndDeclared decls
                  return dd      
          exp _ =return [] 
                   
          match (m@(HsMatch _ (PNT fun _ _)  pats rhs  decls)::HsMatchP)
            |findEntity e rhs || findEntity e decls
            = do (pf,pd) <- hsFreeAndDeclared pats
                 (df,dd) <- hsFreeAndDeclared decls
                 return  (pd `union` dd `union` [fun])
          match _=return []
 
          patBind (p@(Dec (HsPatBind _ pat rhs decls))::HsDeclP)
            |findEntity e rhs || findEntity e decls 
             =do (pf,pd) <- hsFreeAndDeclared pat
                 (df,dd) <- hsFreeAndDeclared decls
                 return (pd `union` dd)
          patBind _=return [] 

          alt ((HsAlt _ pat exp decls)::HsAltP)
             |findEntity e exp || findEntity e decls
             = do (pf,pd) <- hsFreeAndDeclared pat
                  (df,dd) <- hsFreeAndDeclared decls
                  return (pd `union` dd)
          alt _=return []
                    
          stmts ((HsGenerator _ pat exp stmts) :: HsStmtP) 
            |findEntity e stmts
             =do (pf,pd) <-hsFreeAndDeclared pat
                 return pd

          stmts (HsLetStmt decls stmts)
            |findEntity e decls || findEntity e stmts
             =do (df,dd) <-hsFreeAndDeclared decls
                 return dd
          stmts _ =return []

-------------------------------------------------------------------------------
--Class method `declsIn` gets the directly enclosed declarations in a syntax phrase t.

class (Term t) => DeclsIn t where  
    declsIn :: t->[HsDeclI PNT]

instance DeclsIn HsMatchP where   
    declsIn (HsMatch loc1 fun pats rhs ds)=ds 

instance DeclsIn HsDeclP where
    declsIn (Dec (HsPatBind loc p rhs ds))=ds
    declsIn (Dec (HsFunBind loc matches))=concatMap declsIn matches  
    declsIn _ =[]

instance DeclsIn [HsDeclP] where
    declsIn ds=concatMap declsIn ds

instance DeclsIn HsModuleP where
    declsIn (HsModule loc modName exps imps ds)=ds

instance DeclsIn RhsP where
    declsIn rhs=fromMaybe [] (applyTU (stop_tdTU (failTU `adhocTU` inLet
                                                         `adhocTU` inAlt
                                                         `adhocTU` inStmt)) rhs) 
             where inLet ((Exp (HsLet ds e)) ::HsExpP)=Just ds
                   inLet _ =mzero

                   inAlt ((HsAlt _ p rhs ds)::HsAlt HsExpP HsPatP [HsDeclP])=Just ds

                   inStmt ((HsLetStmt ds _)::HsStmt HsExpP HsPatP [HsDeclP])=Just ds
                   inStmt _=mzero

instance DeclsIn HsExpP where
    declsIn rhs=fromMaybe [] (applyTU (stop_tdTU (failTU `adhocTU` inLet
                                                         `adhocTU` inAlt
                                                         `adhocTU` inStmt)) rhs) 
             where inLet ((Exp (HsLet ds e)) ::HsExpP)=Just ds
                   inLet (Exp (HsListComp (HsLetStmt ds stmts)))=Just ds
                   inLet (Exp (HsDo (HsLetStmt ds stmts)))=Just ds
                   inLet _ =Nothing

                   inAlt ((HsAlt _ p rhs ds)::HsAlt HsExpP HsPatP [HsDeclP])=Just ds

                   inStmt ((HsLetStmt ds _)::HsStmt HsExpP HsPatP [HsDeclP])=Just ds
                   inStmt _=Nothing 

instance DeclsIn HsStmtP where
    declsIn (HsLetStmt ds stmts)=ds
    declsIn  _ = []
instance DeclsIn HsAltP where
    declsIn (HsAlt _ p rhs ds)=ds

{-Class method `replaceDecls` replaces the directly enclosed declarations in a syntax phrase t
  by a list of new decls.                                   
-}
class (Term t) => ReplaceDecls t where
  
    replaceDecls :: t->[HsDeclI PNT]->t

instance ReplaceDecls HsExpP where
    replaceDecls (Exp (HsLet ds e)) ds'
            =if ds'==[]
                then e 
                else (Exp (HsLet ds' e))
                     
    replaceDecls (Exp (HsListComp (HsLetStmt ds stmts))) ds'
            =if ds'==[] && isLast stmts 
               then (Exp (HsList [fromJust (expInLast stmts)]))
               else (Exp (HsListComp (HsLetStmt ds' stmts)))
    replaceDecls (Exp (HsDo (HsLetStmt ds stmts))) ds'
            =if ds'==[] 
                then (Exp (HsDo stmts))
                else (Exp (HsDo (HsLetStmt ds' stmts)))
    replaceDecls x ds'=x
   
   
instance ReplaceDecls HsMatchP where   
    replaceDecls (HsMatch loc1 fun pats rhs ds) ds'
                 =(HsMatch loc1 fun pats rhs ds')
           
instance ReplaceDecls HsDeclP where
    replaceDecls (Dec (HsPatBind loc p rhs ds)) ds'
                 =Dec (HsPatBind loc p rhs ds')
    replaceDecls x ds' =x

instance ReplaceDecls HsModuleP where
    replaceDecls (HsModule loc modName exps imps ds) ds'
                  =HsModule loc modName exps imps ds'

instance ReplaceDecls HsAltP where
   replaceDecls (HsAlt loc p rhs ds) ds'=HsAlt loc p rhs ds'

instance ReplaceDecls HsStmtP where
   replaceDecls (HsLetStmt ds stmts) ds'
                    =if ds'/=[] then  HsLetStmt ds' stmts         
                                else stmts

-------------------------------------------------------------------------------------------
{-isDeclaredIn returns True if a name, say p, is declared inside a syntax phrase, say t.
  Otherwise, it returns False. 
-}

class (Term t) => IsDeclaredIn t where
  
    isDeclaredIn :: PName  -- the identifier
                    -> t   -- the syntax phrase.      
                    ->Bool 

instance IsDeclaredIn HsMatchP where   
    isDeclaredIn  pn match@(HsMatch loc1 (PNT fun _ _) pats rhs ds)
             =fromMaybe False ( do (_,d)<-freeAndDeclaredVbls match
                                   Just (elem pn (d \\ [fun])))

instance IsDeclaredIn HsDeclP where
    isDeclaredIn pn (Dec (HsPatBind loc p rhs ds))
            =fromMaybe False (do (_, rd)<-hsFreeAndDeclared rhs
                                 (_, dd)<-hsFreeAndDeclared ds
                                 Just (elem pn (rd `union` dd)))               
    isDeclaredIn pn _ =False 

instance IsDeclaredIn HsModuleP where
    isDeclaredIn pn (HsModule loc modName exps imps ds)
           =fromMaybe False  (do (rf,rd)<-hsFreeAndDeclared ds
                                 Just (elem pn rd))

instance IsDeclaredIn HsExpP where
                                                                 
    isDeclaredIn pn (Exp (HsLambda pats body))
            = fromMaybe False (do (pf,pd) <-hsFreeAndDeclared pats
                                  Just (elem pn  pd))

    isDeclaredIn pn (Exp (HsLet decls e))        
           =fromMaybe False (do (df,dd)<- hsFreeAndDeclared decls
                                Just (elem pn dd))
        
    isDeclaredIn pn _=False 
                   
  
instance IsDeclaredIn HsAltP where
    isDeclaredIn pn (HsAlt _ pat exp decls)
       =fromMaybe False ( do (pf,pd) <- hsFreeAndDeclared pat
                             (df,dd) <- hsFreeAndDeclared decls
                             Just (elem pn (pd `union` dd)))
    
    
instance IsDeclaredIn HsStmtP where
      
    isDeclaredIn pn (HsGenerator _ pat exp stmts) -- Claus
        =fromMaybe False (do (pf,pd) <-hsFreeAndDeclared pat
                             Just (elem pn pd))

    isDeclaredIn pn (HsLetStmt decls stmts)
        =fromMaybe False (do (df,dd) <-hsFreeAndDeclared decls
                             Just (elem pn dd))

    isDeclaredIn pn _=False


--class method `findEntity` returns True if syntax phrase a exists in b, otherwise returns False.
class (Term b)=>FindEntity a b  where
  
  findEntity :: a->b->Bool

instance (Term b)=>FindEntity HsExpP b  where

  findEntity e b
    =(fromMaybe False)(applyTU (once_tdTU (failTU `adhocTU` inExp)) b)
     where
       inExp (e1::HsExpP)
         | e==e1 =Just True
       inExp _ =Nothing

instance (Term b)=>FindEntity PName b  where

  findEntity pn b   
   =(fromMaybe False)(applyTU (once_tdTU (failTU `adhocTU` worker)) b)
     where 
        worker (Exp (HsId (HsVar (PNT pname _ _))))
           |pname==pn= Just True
        worker _ =Nothing 

instance (Term b)=>FindEntity PNT b where

  findEntity pnt b
   =(fromMaybe False)(applyTU (once_tdTU (failTU `adhocTU` worker)) b)
      where 
        worker (pnt1::PNT)
           |samePNT pnt pnt1 = Just True

        worker _ =Nothing 

                                    
----------------------------------------------------------------------------------------- 
  
---IMPORTANT FUNCTION   
doMoving pns dest destPos sameLevel paramsAdded decls 
   = do  
        ((ts,_),_)<-get  
        --'dest' of the parent decl of the moved decl. 
        let (startPos@(_,startCol),endPos)=startEndLocIncFowNewLn ts dest
            typeSig=filter isTypeSig (definingDecls pns decls True False)
        decls'<-foldM (flip rmTypeSig) decls pns
        --decls'' is the remained decls after deleting the decl defining pns
        --defToks is the tokens that have been removed. These token will be moved to another level.
        (decls'',defToks)<-rmLocalFunOrPatBind (ghead "doMoving" pns) decls'  --pns can not be empty
        --get the tokens after removing the selected declaration.
        ((toks,_),others)<-get     
        if isJust destPos  --The destination position is specified.
           then do let (destRow,destCol)=fromJust destPos  --get the destination position
                       (toks1,toks2)=break (\t->tokenPos t>=(destRow,destCol)) toks
                       origCol=tokenCol $ ghead "doMoving:then" (dropWhile isWhite defToks)
                       realDestCol=length (concatMap tokenCon (filter (\t->tokenRow t==destRow) toks1))
                       offset=realDestCol-origCol+1
                       --adjust the offset of the moved declaration
                       newDeclToks=adjustOffset offset defToks False 
                       newDeclToks'=if newDeclToks==[] || endsWithNewLn (glast "doMoving" newDeclToks)
                                       then newDeclToks
                                       else newDeclToks++[newLnToken]
                       sigToks=if typeSig==[] then []
                           else [mkToken Whitespace (0,0) 
                                 $ concatMap (\s->whiteSpaces (realDestCol-1)++s++"\n") ((lines.render.ppi) typeSig)]  
                       toks'=if paramsAdded --Type signature should be changed to reflect the parameter.
                                then (toks1++newDeclToks'++whiteSpacesToken (0,0) realDestCol++toks2)
                                else (toks1++sigToks++newDeclToks'++whiteSpacesToken (0,0) realDestCol++toks2)
                   put ((toks',modified),others) 
           else  --The destination position is not specified.
                do let parentToks=compressEndNewLns $ getToks (startPos,endPos) toks 
                       defToks'=dropWhile isWhite defToks
                       origCol=tokenCol $ ghead "doMoving:else" defToks'
                       realDestCol=if sameLevel then startCol else startCol+6
                       offset=realDestCol-origCol
                       --adjust the offset of the moved declaration
                       newDeclToks=adjustOffset offset defToks' False
                       --add preceding white spaces and following '\n' if necessary
                       newDeclToks'=compressPreNewLns $ whiteSpacesToken (0,0) (realDestCol-1)++newDeclToks
                       -- add type signature if there is one
                       sigToks=if typeSig==[] then []
                               else [mkToken Whitespace (0,0)  --pretty print the type signature.
                                    $ concatMap (\s->whiteSpaces (realDestCol-1)++s++"\n") ((lines.render.ppi) typeSig)] 
                       newDeclToks''=if paramsAdded then newDeclToks'
                                          else sigToks++ newDeclToks'                                        
                       newDeclToks'''=if sameLevel 
                                        then  newDeclToks''   --Any Problem here?
                                        else (mkToken Special (0,0) (whiteSpaces (realDestCol-4) ++"where\n")):newDeclToks''
                       --handle new lines
                       toks'=if endsWithNewLn (lastNonSpaceToken parentToks) 
                                 && startsWithNewLn (firstNonSpaceToken  newDeclToks''')
                             then replaceToks toks startPos endPos (parentToks++newDeclToks''')
                             else if endsWithNewLn (lastNonSpaceToken parentToks) 
                                      || startsWithNewLn (firstNonSpaceToken  newDeclToks''')
                                    then if sameLevel  
                                           then  replaceToks toks startPos endPos (parentToks++[newLnToken]++newDeclToks''')
                                           else  replaceToks toks startPos endPos (parentToks++newDeclToks''')
                                    else if sameLevel
                                         then replaceToks toks startPos endPos (parentToks++[newLnToken,newLnToken]++newDeclToks''')
                                         else replaceToks toks startPos endPos (parentToks++[newLnToken]++newDeclToks''')
                   put ((toks',modified),others)            
        return decls''
 
 
 ---IMPORTANT FUNCTION. this function is only used in demoting.
--The function name should be renamed later.
{-This function moves the declaration that defines pns to be a location decl of dest.
-}
doMoving1 pns dest decls paramsFolded
   = do ((ts,_),_)<-get
        let (startPos@(_,startCol),endPos)=startEndLocIncFowComment ts dest           
            typeSig=filter isTypeSig (definingDecls pns decls True False )
        decls'<-foldM (flip rmTypeSig) decls pns 
        (decls'',defToks)<-rmLocalFunOrPatBind (ghead "doMoving1"  pns) decls'  
        ((toks,_),others)<-get   
        let parentToks=compressEndNewLns $ getToks (startPos,endPos) toks  
            origCol=tokenCol $ ghead "doMoving1"  $  dropWhile isWhite defToks
            localDecls=declsIn dest
            realDestCol=if localDecls==[]
                          then startCol+4
                          else (snd.fst) (getStartEndLoc toks (ghead "doMoving" localDecls)) 
            offset=realDestCol-origCol
            typeSigLines=(nub ((lines.render.ppi) typeSig)) \\[" "] --remove the empty lines between type sig.
            sigToks=if typeSig==[] then []
                        else [mkToken Varid (0,0) 
                             $ concatMap (\s->whiteSpaces (realDestCol-1)++s++"\n") (init typeSigLines) ++
                               whiteSpaces (realDestCol-1)++glast "doMoving1" typeSigLines]  

            newDeclToks'=whiteSpacesToken (0,0) (tokenCol (head defToks) -1) ++
                          adjustOffset offset (compressPreNewLns defToks) True
            newDeclToks''=if paramsFolded then newDeclToks'
                                          else if startsWithEmptyLn newDeclToks' 
                                                  then sigToks++newDeclToks'           
                                                  else sigToks++[newLnToken]++newDeclToks'
            newDeclToks'''=
                    if localDecls/=[]
                       then newDeclToks''
                       else if startsWithEmptyLn newDeclToks'' 
                              then (mkToken Special (0,0) (whiteSpaces (startCol-1)++"  where")):newDeclToks''
                              else (mkToken Special (0,0) (whiteSpaces (startCol-1)++"  where\n")):newDeclToks''
            toks'=if endsWithNewLn (lastNonSpaceToken  parentToks) || startsWithEmptyLn newDeclToks'''
                   then replaceToks toks startPos endPos (parentToks++newDeclToks''')
                   else replaceToks toks startPos endPos (parentToks++[newLnToken]++newDeclToks''')     
        put ((toks',modified),others)



whiteSpaces n = replicate n ' '

getDeclToks pns typeSig funBinding toks 
  =if typeSig ==[] || definesSingleId (ghead "addCodeToMod" typeSig)
     then let (startPos, endPos) = startEndLocIncComments toks funBinding
              (toks1,_) = break (\t->tokenPos t > endPos) toks
               --get the token stream for the definition.
          in  dropWhile (\t-> tokenPos t <startPos || isNewLn t) toks1 
     else let typeSig'= ghead "addCodeToMod" $ getTypeSig pns (head typeSig)
              (startPos, endPos) = startEndLocIncComments toks funBinding
              (toks1,_) = break (\t->tokenPos t > endPos) toks
               --get the token stream for the function binding.
              toks2= dropWhile (\t-> tokenPos t <startPos || isNewLn t) toks1
              t = mkToken Whitespace (0,0) $ concatMap (\s->s++"\n") (astToSource typeSig')
          in (t:toks2)     
  where
    -- Get the type signatures defines the type of pns. 
    getTypeSig pns (Dec (HsTypeSig loc is c tp))
       =[(Dec (HsTypeSig loc (filter (\x->isJust (find (==pNTtoPN x) pns)) is) c tp))]
    getTypeSig pns _ = []
      
    definesSingleId  (Dec (HsTypeSig loc is c tp)) = length is ==1 