{-+
All of the built-in entities that don't contain any recursive parts (mainly
names). 
-}
module HsConstants(module HsConstants,module SpecialNames,HsName) where

import HsName
import HsIdent
import HsExpStruct
import SpecialNames

prelude_mod_name = "Prelude"

-- Haskell 98 Prelude & standard library modules:
prelude_mod         = mod_Prelude -- retained for backward compatibility
mod_Prelude         = plainModule prelude_mod_name
mod_PreludeList     = plainModule "PreludeList" -- implemenation specific name
mod_PreludeText     = plainModule "PreludeText" -- implemenation specific name
mod_Ix		    = plainModule "Ix"

main_mod path       = moduleName path "Main"

--qualify path m v         = Qual (moduleName path m) v
tuple n            = "(" ++ replicate n ',' ++ ")"        

unit_con_name       = Qual prelude_mod "()"
tuple_con_name n    = Qual prelude_mod $ tuple n

unit_con            = HsId $ HsCon unit_con_name
tuple_con n         = HsId $ HsCon $ tuple_con_name n

as_name             = UnQual "as"
qualified_name      = UnQual "qualified"
hiding_name         = UnQual "hiding"
minus_name          = UnQual "-"
pling_name          = UnQual "!"
period_name         = UnQual "."
main_name           = UnQual "main"

unit_tycon_name     = unit_con_name

instance HasSpecialNames HsName where
  fun_tycon_name      = Qual prelude_mod "->"
  list_tycon_name     = Qual prelude_mod "[]"
  char_tycon_name     = Qual prelude_mod "Char"
  tuple_tycon_name n  = tuple_con_name n



instance IsSpecialName HsName where
  is_list_tycon_name  = std_is_list_tycon_name
  is_fun_tycon_name   = std_is_fun_tycon_name
  is_char_tycon_name  = std_is_char_tycon_name
  is_tuple_tycon_name = std_is_tuple_tycon_name



