module PosSyntax(module PosSyntax,module Syntax,module HsConstants,
		 module SpecialNames,SN,module PosName,
		 --Reexport constructor that are accidentally hidden below...
		 HsFieldI(..),HsImportDeclI(..),HsConDeclI(..)
      ) where
import Syntax hiding (ModuleName,HsName,Id{-,HsIdent,HsExp,HsPat,HsDecl,HsType,
		      HsField,HsExportSpec,HsImportSpec,
		      HsModuleR-},hsMainModule,hsTyTuple,main_name)
import qualified Syntax as Hs
import HsConstants(main_mod,mod_Prelude,tuple)
import qualified HsConstants as Hs
--import PrettyPrint
import SourceNames
import PosName
import SpecialNames
import QualNames(isQual)
-- import Entity

pos i p = SN i p

type HsExp = HsExpI HsName
type HsPat = HsPatI HsName
type HsDecl = HsDeclI HsName
type HsType = HsTypeI HsName

type HsField = HsFieldI HsName
type HsImportDecl = HsImportDeclI ModuleName HsName
type HsConDecl = HsConDeclI HsName
type HsExportSpec = HsExportSpecI ModuleName HsName
type HsImportSpec = HsImportSpecI HsName
type HsModuleR = HsModuleI ModuleName HsName [HsDecl]

qualid (p,s) = pos (splitQualName (srcFile p) s) p

unqualid (p,s) = pos (UnQual s) p

qualify m n = pos (Qual m n)

minus_name = pos Hs.minus_name
pling_name = pos Hs.pling_name
period_name = pos Hs.period_name
as_name = pos Hs.as_name
qualified_name = pos Hs.qualified_name
hiding_name = pos Hs.hiding_name
foreign_name p = unqualid (p,"foreign")

unit_tycon_name = pos Hs.unit_tycon_name

list_tycon = hsTyCon . list_tycon_name :: SrcLoc -> HsType
tuple_tycon n = hsTyCon . tuple_tycon_name n :: SrcLoc -> HsType

hsTyTuple p ts = foldl hsTyApp (tuple_tycon (length ts-1) p) ts

isQualified = isQual :: HsName -> Bool

-- An omitted module header is equivalent to module Main(main) where ...
hsMainModule loc body =
    hsModule loc (pos (main_mod (srcFile loc)) loc)
             (Just [exportVar (main_name loc)]) body
main_name = pos Hs.main_name
