module DerivingEnum where
import DerivingUtils

deriveEnum src t@(_,TypeInfo{constructors=cs}) =
    if isEnum cs
    then return (fromToEnum src t id)
    else fail "Deriving Enum: the type is not an enumeration."

fromToEnum src t@(_,TypeInfo{constructors=cs}) sig = [fromEnumDef,toEnumDef]
 where
  cns = zip [0..] cs

  fromEnumDef = fun src (map fromAlt cns)
  toEnumDef = fun src (map toAlt cns)

  fromAlt (n,ci) = alt1 src fromEnum (con c)
			((if n==0 then sig else id) (lit (HsInt src n)))
    where c = convCon t (conName ci)

  toAlt (n,ci) = alt1 src toEnum (lit (HsInt src n)) (con c)
    where c = convCon t (conName ci)

  fromEnum = prelVal "fromEnum"
  toEnum = prelVal "toEnum"
