
# Auxiliary functions for validation of certificates.

. "$PROGRAMATICA/functions.sh"


### Functions ##################################################################

trivialmarkvalid() {
 echo '[]' >"$deps" && datestamp valid $certpath $module
}

markvalid() {
  pfe tasig "$assertion" >"$deps" && datestamp valid $certpath $module
}

markinvalid() { datestamp invalid $certpath $module; }


checkassertion() {
  m="${1%.*}"
  a="${1##*.}"
  # Check that the argument is a qualified name and that the assertion exists.
  [ "$a" != "$1" ] && pfe assertions "$m" | grep -q "^$m $a\$"
}

### Initialization #############################################################
### Perform some sanity checks and define some useful variables:

[ -n "$certsDir" ] || abort 'Bug: $certsDir is not set'
[ -n "$1" ] || abort 'Bug: validate called without a certificate argument'

cert="$1"
certpath="$certsDir$cert"

checkproject
checkcert "$cert" # Sets $attr
deps="$certpath/deps" # Name of file containting PFE dependency information
output="$certpath/output.txt" # Standard place for diagnostic output

conc=`getattr conc "$attr"`
module="${cert%/*}"
assertion="$module.$conc"

checkassertion "$module.$conc" || {
  abort "Did't find the assertion $conc in module $module"
}
